IMPLEMENTATION MODULE Bars;

(******************************************************************)
(*											*)
(*				     Bars Module					*)
(*											*)
(*	Programmer :	Matthew Ma (c9315720)				*)
(*											*)
(*	Last edited :	22-10-97						*)
(*											*)
(*	Function : 		This module draws the menu bar, menu	*)
(*				buttons, the title bar, the status bar,	*)
(*				the icon bar, and the small window at	*)
(*				the lower-left corner of the screen.	*)
(* 											*)
(*	Status :		Working.						*)
(******************************************************************)


FROM Toolbox IMPORT
(* var *)    marquee_x1, marquee_y1, marquee_x2, marquee_y2;

IMPORT ImageRoutines;

FROM TerminationControl IMPORT
(* proc *)   Crash;

FROM FileRoutines IMPORT
(* var  *)   modified,
(* proc *)   BrightnessInput;

FROM InfoDialogs IMPORT
(* proc *)   ShowImageInfo, Restart, UniqueColours,
		 AboutPaintMagic, Exit, FileModified;

FROM ColourRoutines IMPORT
(* proc *)   InvertPalette, BrightnessControl, GreyScale;

FROM FileRoutines IMPORT
(* type *)   Actions, modified, new_image, open, FileTypes,
(* var  *)   extension, NewImage, Convert, CaptFileName1, CaptFileName2;

FROM SetModes IMPORT
(* proc *)   ChangeMode;

FROM GraphicWindow IMPORT
(* type *)   GraphicalWindow,
(* var  *)   CharWidth, CharHeight, XMAX, YMAX,
(* proc *)   CreateGraphicalWindow, DisplayWindowTitle, DoNothing, PutRectangle,
             ClearDataRegion, DisplayWindowData, PutString, PutTitleStrip,
             ObtainScreen, ReleaseScreen, Line, Rectangle, DisplayString,
	       MouseParatemer_xoffset, MouseParatemer_yoffset, PutLine;

FROM Canvas IMPORT
(* var  *)   CanvasLeft, CanvasTop, CanvasRight, CanvasBottom,
		 normal, zoom2x, zoom3x, IsMarquee, ShowOrdinate,
(* proc *)   MsgCanvas; 

FROM FileRoutines IMPORT
(* proc *)   OpenFile, SaveFile, SaveFileAs,ChangePath,DeleteFile;

FROM MouseRoutines IMPORT
(* proc *)   SetFinger, SetArrow;

FROM Buttons IMPORT
(* var  *)   NoSubMenu,
(* type *)   BoxMenuProcedure, BoxMenuItemTYPE, BoxMenuTYPE, MenuType,
(* proc *)   CreateBoxSubMenu, BoxSubMenuItemSetup, DisplayBoxSubMenuTitle,
        	 DisplayBoxSubMenu, BoxSubMenuKeyboardSelection, NoIconDraw;

FROM InfoDialogs IMPORT
(* proc *)   ShowImageInfo;

FROM PopUpWindows IMPORT
(* proc *)   Palette256, Index;

FROM Icons IMPORT
(* const *)  arrow, freehand, line, rectangle, solid_rectangle, circle, solid_circle,
             text, eraser, floodfill, airbrush, dropper, marquee, zoom, crosshair,
	       small_eraser, medium_eraser, large_eraser, hv_line, square, solid_square,
	       small_brush, medium_brush, large_brush, capture1, capture2;

FROM SoundEffects IMPORT
(* proc *)   Beep;


CONST
   x_offset = 5;
   y_offset = 10;

VAR
   dummy, option : CARDINAL;
   StatusBar, TitleBar, MenuBar, IconBar, EmptyWindow : GraphicalWindow;



(******************************************************************)
(* A dummy procedure.								*)
(******************************************************************)
PROCEDURE Dummy;
BEGIN
END Dummy;

(******************************************************************)
(* This procedure clears the status bar.					*)
(******************************************************************)
PROCEDURE ClearStatusBar();
BEGIN
   ClearDataRegion(StatusBar);
END ClearStatusBar;

(******************************************************************)
(* This procedure updates the status bar.					*)
(******************************************************************)
PROCEDURE UpdateStatusBar(string : ARRAY OF CHAR; x,y : INTEGER; colour : CARDINAL);
BEGIN
  IF (ObtainScreen()) THEN
     ClearDataRegion(StatusBar);
     PutString(StatusBar,string,x,y,colour,FALSE);
     ReleaseScreen();
  END;
END UpdateStatusBar;

(******************************************************************)
(* This procedure clears the title bar.					*)
(******************************************************************)
PROCEDURE ClearTitleBar();
BEGIN
   ClearDataRegion(TitleBar);
END ClearTitleBar;

(******************************************************************)
(* This procedure updates the title bar.					*)
(******************************************************************)
PROCEDURE UpdateTitleBar(string : ARRAY OF CHAR; x,y : INTEGER; colour : CARDINAL);
BEGIN
  IF (ObtainScreen()) THEN
     ClearDataRegion(TitleBar);
     PutString(TitleBar,string,x,y,colour,FALSE);
     ReleaseScreen();
  END;
END UpdateTitleBar;

(******************************************************************)
(* This procedure draws the status bar.					*)
(******************************************************************)
PROCEDURE DrawStatusBar();
BEGIN
   CreateGraphicalWindow(StatusBar,0-3+3-2,YMAX-21+3,XMAX+3-3+3,YMAX+3,7,NIL,0,0,15,1,
                     	 TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,DoNothing, DoNothing,SetArrow);
   IF (ObtainScreen()) THEN
    	DisplayWindowData(StatusBar);
    	ReleaseScreen();
   END;
END DrawStatusBar;

(******************************************************************)
(* This procedure draws the menu bar.					*)
(******************************************************************)
PROCEDURE DrawMenuBar();
BEGIN
   CreateGraphicalWindow(MenuBar,0-3,0-3+19+1,XMAX+2+1,34+12,7,NIL,0,0,15,1,
				 TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,DoNothing,DoNothing,SetArrow);
   IF (ObtainScreen()) THEN
    	DisplayWindowData(MenuBar);
    	ReleaseScreen();
   END;
END DrawMenuBar;

(******************************************************************)
(* This procedure draws the title bar.					*)
(******************************************************************)
PROCEDURE DrawTitleBar();
BEGIN
   CreateGraphicalWindow(TitleBar,0-3+3-2,0-3,XMAX+2-2+3,34-16,7-6,NIL,0,0,15,1,
                     	 TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,DoNothing,DoNothing,SetArrow);
   IF (ObtainScreen()) THEN
    	DisplayWindowData(TitleBar);
    	ReleaseScreen();
   END;
END DrawTitleBar;

(******************************************************************)
(* This procedure draws the icon bar.					*)
(******************************************************************)
PROCEDURE DrawIconBar();
BEGIN
   CreateGraphicalWindow(IconBar,0-3,34-7+17+1,XMAX+3,68+11+3,7,NIL,0,0,15,1,
                     	TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,DoNothing,DoNothing,SetArrow);
   IF (ObtainScreen()) THEN
    	DisplayWindowData(IconBar);
    	ReleaseScreen();
   END;
END DrawIconBar;

(******************************************************************)
(* This procedure draws the transparent rectangle/square tool	*)
(* options on the options window.						*)
(******************************************************************)
PROCEDURE RectangleOptions(opt : INTEGER);
VAR
   ok : BOOLEAN;
BEGIN
   CASE opt OF
	  1:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,15,436-386,38,443-378,1,TRUE);
      	PutRectangle(EmptyWindow,18,436-383,35,443-381,15,FALSE);
		PutRectangle(EmptyWindow,52+3,436-384,69-3,443-380,0,FALSE);
		ReleaseScreen();

	| 2:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,18,436-383,35,443-381,0,FALSE);
      	PutRectangle(EmptyWindow,50,436-386,71,443-378,1,TRUE);
		PutRectangle(EmptyWindow,52+3,436-384,69-3,443-380,15,FALSE);
		ReleaseScreen();

   	ELSE
   END;
END RectangleOptions;

(******************************************************************)
(* This procedure draws the solid rectangle/square tool options	*)
(* on the options window.							*)
(******************************************************************)
PROCEDURE SolidRectangleOptions(opt : INTEGER);
VAR
   ok : BOOLEAN;
BEGIN
   CASE opt OF
	  1:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,15,436-386,38,443-378,1,TRUE);
      	PutRectangle(EmptyWindow,18,436-383,35,443-381,15,TRUE);
		PutRectangle(EmptyWindow,52+3,436-384,69-3,443-380,0,TRUE);
		ReleaseScreen();

	| 2:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,18,436-383,35,443-381,0,TRUE);
      	PutRectangle(EmptyWindow,50,436-386,71,443-378,1,TRUE);
		PutRectangle(EmptyWindow,52+3,436-384,69-3,443-380,15,TRUE);
		ReleaseScreen();
	
   	ELSE
   END;
END SolidRectangleOptions;

(******************************************************************)
(* This procedure draws the line tool options on the options	*)
(* window.										*)
(******************************************************************)
PROCEDURE LineOptions(opt : INTEGER);
VAR
   ok : BOOLEAN;
BEGIN
   CASE opt OF
	  1:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,15,436-386,38,443-378,1,TRUE);
      	PutLine(EmptyWindow,18+1,436-383+1,35-1,443-381-1,15);
		PutLine(EmptyWindow,53+3,436-383,53+3,443-381,0);
		PutLine(EmptyWindow,53,436-383+3,68,436-383+3,0);
		ReleaseScreen();

	| 2:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutLine(EmptyWindow,18+1,436-383+1,35-1,443-381-1,0);
      	PutRectangle(EmptyWindow,50,436-386,71,443-378,1,TRUE);
		PutLine(EmptyWindow,53+3,436-383,53+3,443-381,15);
		PutLine(EmptyWindow,53,436-383+3,68,436-383+3,15);
		ReleaseScreen();
	
   	ELSE
   END;
END LineOptions;

(******************************************************************)
(* This procedure draws the eraser tool options on the options	*)
(* window.										*)
(******************************************************************)
PROCEDURE EraserOptions(opt : INTEGER);
VAR
   ok : BOOLEAN;
BEGIN
   CASE opt OF
	  1:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,19-4,438-382-4,22+4,441-382+4,1,TRUE);
		PutRectangle(EmptyWindow,19,438-382,22,441-382,15,TRUE);
      	PutRectangle(EmptyWindow,41,437-382,46,442-382,0,TRUE);
      	PutRectangle(EmptyWindow,63,436-382,70,443-382,0,TRUE);
		ReleaseScreen();

	| 2:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,19,438-382,22,441-382,0,TRUE);
		PutRectangle(EmptyWindow,41-3,437-382-3,46+3,442-382+3,1,TRUE);
      	PutRectangle(EmptyWindow,41,437-382,46,442-382,15,TRUE);
      	PutRectangle(EmptyWindow,63,436-382,70,443-382,0,TRUE);
		ReleaseScreen();

	| 3:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,19,438-382,22,441-382,0,TRUE);
      	PutRectangle(EmptyWindow,41,437-382,46,442-382,0,TRUE);
		PutRectangle(EmptyWindow,63-2,436-382-2,70+2,443-382+2,1,TRUE);
      	PutRectangle(EmptyWindow,63,436-382,70,443-382,15,TRUE);
		ReleaseScreen();

   	ELSE
   END;
END EraserOptions;

(******************************************************************)
(* This procedure draws the brush tool options on the options	*)
(* window.										*)
(******************************************************************)
PROCEDURE BrushOptions(opt : INTEGER);
VAR
   ok : BOOLEAN;
BEGIN
   CASE opt OF
	  1:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
		PutRectangle(EmptyWindow,19-4,438-382-4,22+4,441-382+4,1,TRUE);

		PutRectangle(EmptyWindow,20,56,21,59,15,TRUE);
		PutRectangle(EmptyWindow,19,57,22,58,15,TRUE);

		PutRectangle(EmptyWindow,42,55,44,61,0,TRUE);
		PutRectangle(EmptyWindow,41,56,45,60,0,TRUE);
		PutRectangle(EmptyWindow,40,57,46,59,0,TRUE);

		PutRectangle(EmptyWindow,65,54,68,61,0,TRUE);
		PutRectangle(EmptyWindow,64,55,69,60,0,TRUE);
		PutRectangle(EmptyWindow,63,56,70,59,0,TRUE);
		ReleaseScreen();

	| 2:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);

		PutRectangle(EmptyWindow,20,56,21,59,0,TRUE);
		PutRectangle(EmptyWindow,19,57,22,58,0,TRUE);

		PutRectangle(EmptyWindow,41-3-1,437-382-3,46+3,442-382+3,1,TRUE);

		PutRectangle(EmptyWindow,42,55,44,61,15,TRUE);
		PutRectangle(EmptyWindow,41,56,45,60,15,TRUE);
		PutRectangle(EmptyWindow,40,57,46,59,15,TRUE);

		PutRectangle(EmptyWindow,65,54,68,61,0,TRUE);
		PutRectangle(EmptyWindow,64,55,69,60,0,TRUE);
		PutRectangle(EmptyWindow,63,56,70,59,0,TRUE);
		ReleaseScreen();

	| 3:
		ok := ObtainScreen();
		PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);

		PutRectangle(EmptyWindow,20,56,21,59,0,TRUE);
		PutRectangle(EmptyWindow,19,57,22,58,0,TRUE);

		PutRectangle(EmptyWindow,42,55,44,61,0,TRUE);
		PutRectangle(EmptyWindow,41,56,45,60,0,TRUE);
		PutRectangle(EmptyWindow,40,57,46,59,0,TRUE);

		PutRectangle(EmptyWindow,63-2,436-382-2,70+2,443-382+2,1,TRUE);

		PutRectangle(EmptyWindow,65,54,68,61,15,TRUE);
		PutRectangle(EmptyWindow,64,55,69,60,15,TRUE);
		PutRectangle(EmptyWindow,63,56,70,59,15,TRUE);
		ReleaseScreen();

   	ELSE
   END;
END BrushOptions;

(******************************************************************)
(* This procedure sets the option number.					*)
(******************************************************************)
PROCEDURE SetOption(num : CARDINAL);
BEGIN
   option := num;
END SetOption;

(******************************************************************)
(* This procedure respond to mouse movements and clicks in the	*)
(* window on the lower-left corner of screen.				*)
(******************************************************************)
PROCEDURE EmptyResponse(window : GraphicalWindow; temp_x,temp_y : INTEGER;
          			LeftPressed,LeftReleased,DoubleClicked,Drag : BOOLEAN);
VAR
   ok : BOOLEAN;
BEGIN
   IF option <> 0 THEN
      IF (MouseParatemer_xoffset >= 10) AND (MouseParatemer_xoffset <= 77) AND
         (MouseParatemer_yoffset >= 48) AND (MouseParatemer_yoffset <= 68) THEN
         SetFinger();
      END;
   END;

   IF (option = 1) OR (option =2) THEN	(* eraser or brush options *)
      IF (LeftPressed) AND NOT(Drag) AND (MouseParatemer_xoffset >= 10)
         AND (MouseParatemer_xoffset <= 31) AND (MouseParatemer_yoffset >= 48)
         AND (MouseParatemer_yoffset <= 68) THEN

	   CASE option OF
		  1:
         		MsgCanvas(2, small_eraser);
         		EraserOptions(1);

		| 2:
		  	BrushOptions(1);
		  	MsgCanvas(2, small_brush);

		ELSE
	   END; (* CASE *)
      END; (* IF *)

      IF (LeftPressed) AND NOT(Drag) AND (MouseParatemer_xoffset >= 33)
         AND (MouseParatemer_xoffset <= 52) AND (MouseParatemer_yoffset >= 48)
         AND (MouseParatemer_yoffset <= 68) THEN

	   CASE option OF
		  1:
         		MsgCanvas(2, medium_eraser);
         		EraserOptions(2);

		| 2:
		  	BrushOptions(2);
		  	MsgCanvas(2, medium_brush);

		ELSE
	   END; (* CASE *)
      END; (* IF *)

      IF (LeftPressed) AND NOT(Drag) AND (MouseParatemer_xoffset >= 56)
         AND (MouseParatemer_xoffset <= 77) AND (MouseParatemer_yoffset >= 48)
         AND (MouseParatemer_yoffset <= 68) THEN

	   CASE option OF
		  1:
         		MsgCanvas(2, large_eraser);
         		EraserOptions(3);
		| 2:
		  	BrushOptions(3);
		  	MsgCanvas(2, large_brush);
		ELSE
	   END; (* CASE *)
      END; (* IF *)

   ELSIF (option = 3) OR (option = 4) OR (option = 5) THEN
	IF (LeftPressed) AND NOT(Drag) AND (MouseParatemer_xoffset >= 10)
         AND (MouseParatemer_xoffset <= 43) AND (MouseParatemer_yoffset >= 48)
         AND (MouseParatemer_yoffset <= 68) THEN
	   CASE option OF
		  3:
            	MsgCanvas(2, rectangle);
			RectangleOptions(1);

		| 4:
			MsgCanvas(2, solid_rectangle);
			SolidRectangleOptions(1);

		| 5:
			MsgCanvas(2, line);
			LineOptions(1);

		ELSE
	    END; (* CASE *)
       END; (* IF *)

	 IF (LeftPressed) AND NOT(Drag) AND (MouseParatemer_xoffset >= 44)
         AND (MouseParatemer_xoffset <= 77) AND (MouseParatemer_yoffset >= 48)
         AND (MouseParatemer_yoffset <= 68) THEN
         CASE option OF
		  3:
            	MsgCanvas(2, square);
			RectangleOptions(2);

		| 4:
			MsgCanvas(2, solid_square);
			SolidRectangleOptions(2);

		| 5:
			MsgCanvas(2, hv_line);
			LineOptions(2);

		ELSE
	   END; (* CASE *)
      END; (* IF *)

   ELSE
   END;
END EmptyResponse;


(******************************************************************)
(* This procedure draws the window on the lower-left of screen.	*)
(******************************************************************)
PROCEDURE DrawEmptyWindow();
VAR
   ok : BOOLEAN;
BEGIN
   CreateGraphicalWindow(EmptyWindow,0-3,320+60,88,YMAX-17,15-8,NIL,0,0,0,7,
				 TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,DoNothing,EmptyResponse,SetArrow);

   ok := ObtainScreen();
   DisplayWindowData(EmptyWindow);

   PutRectangle(EmptyWindow,15,390-383,50,415-3-383,0,FALSE);
   PutRectangle(EmptyWindow,36,405-2-2-383,71,430-3-2-2-383,0,FALSE);

   PutRectangle(EmptyWindow,16,391-383,49,414-3-383,0+16,TRUE);

   PutRectangle(EmptyWindow,51,406-2-2-383,70,415-3-383,15+16,TRUE);
   PutRectangle(EmptyWindow,37,416-3-383,70,429-3-2-2-383,15+16,TRUE);

   PutRectangle(EmptyWindow,3,384-383,81+1,456-383,8,FALSE);
   PutLine(EmptyWindow,4,385-383,4,455-383,15);
   PutLine(EmptyWindow,4,385-383,80+1,385-383,15);
   PutLine(EmptyWindow,3,457-383,82+1,457-383,15);
   PutLine(EmptyWindow,82+1,457-383,82+1,384-383,15);

   PutLine(EmptyWindow,8,429-383,8,452-383,0);
   PutLine(EmptyWindow,8,429-383,78,429-383,0);
   PutLine(EmptyWindow,9,430-383,9,451-383,8);
   PutLine(EmptyWindow,9,430-383,78,430-383,8);
   PutLine(EmptyWindow,78,430-383,78,452-383,15);
   PutLine(EmptyWindow,9,452-383,78,452-383,15);

   ReleaseScreen();
END DrawEmptyWindow;

(******************************************************************)
(* This procedure updates the foreground colour.			*)
(******************************************************************)
PROCEDURE UpdateForegroundColour(idx : SHORTCARD);
VAR
   ok : BOOLEAN;
BEGIN
   ok := ObtainScreen();
   PutRectangle(EmptyWindow,16,391-383,49,414-3-383,CARDINAL(idx),TRUE);
   ReleaseScreen();
END UpdateForegroundColour;

(******************************************************************)
(* This procedure updates the background colour.			*)
(******************************************************************)
PROCEDURE UpdateBackgroundColour(idx : SHORTCARD);
VAR
   ok : BOOLEAN;
BEGIN
   ok := ObtainScreen();
   PutRectangle(EmptyWindow,51,406-2-2-383,70,415-3-383,CARDINAL(idx),TRUE);
   PutRectangle(EmptyWindow,37,416-3-383,70,429-3-2-2-383,CARDINAL(idx),TRUE);
   ReleaseScreen();
END UpdateBackgroundColour;

(******************************************************************)
(* This procedure updates the test colour probed by the colour	*)
(* dropper tool.									*)
(******************************************************************)
PROCEDURE UpdateTestColour(idx : SHORTCARD);
VAR
   ok : BOOLEAN;
BEGIN
   PutRectangle(EmptyWindow,10,431-383,77,451-383,CARDINAL(idx),TRUE);
END UpdateTestColour;

(******************************************************************)
(* This procedure clears the options window.				*)
(******************************************************************)
PROCEDURE ClearOptionsWindow();
VAR
   ok : BOOLEAN;
BEGIN
   ok := ObtainScreen();
   PutRectangle(EmptyWindow,10,431-383,77,451-383,7,TRUE);
   ReleaseScreen();
END ClearOptionsWindow;

(******************************************************************)
(* This procedure calls the OpenFile procedure.				*)
(******************************************************************)
PROCEDURE DoOpen();
BEGIN
   open := TRUE;
   IF NOT(modified) THEN
	OpenFile();
   ELSE
	new_image := FALSE;
	Beep();
	FileModified();
   END;
END DoOpen;

(******************************************************************)
(* This procedure sets screen mode to 640x480x256.			*)
(******************************************************************)
PROCEDURE Set640x480x256();
BEGIN
   ChangeMode(1);
   Beep();
   Restart();
END Set640x480x256;

(******************************************************************)
(* This procedure sets screen mode to 800x600x256.			*)
(******************************************************************)
PROCEDURE Set800x600x256();
BEGIN
   ChangeMode(2);
   Beep();
   Restart();
END Set800x600x256;

(******************************************************************)
(* This procedure sets screen mode to 1024x768x256.			*)
(******************************************************************)
PROCEDURE Set1024x768x256();
BEGIN
   ChangeMode(3);
   Beep();
   Restart();
END Set1024x768x256;

(******************************************************************)
(* This procedure sets screen mode to 1280x1024x256.			*)
(******************************************************************)
PROCEDURE Set1280x1024x256();
BEGIN
   ChangeMode(4);
   Beep();
   Restart();
END Set1280x1024x256;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* MirrorImage routine.								*)
(******************************************************************)
PROCEDURE Mirror();
BEGIN
   MsgCanvas(9,dummy);
END Mirror;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* FlipImage routine.								*)
(******************************************************************)
PROCEDURE Flip();
BEGIN
   MsgCanvas(8,dummy);
END Flip;

(******************************************************************)
(* This procedure carries out the InvertPalette routine.		*)
(******************************************************************)
PROCEDURE Invert();
BEGIN
   InvertPalette();
   modified := TRUE;
END Invert;

(******************************************************************)
(* This procedure carries out the GreyScale routine.		*)
(******************************************************************)
PROCEDURE GreyScaling();
BEGIN
   GreyScale();
   modified := TRUE;
END GreyScaling;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* zooming routine.								*)
(******************************************************************)
PROCEDURE NormalView();
BEGIN
   IF NOT(normal) THEN
      MsgCanvas(6+6,dummy);
   END;
END NormalView;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* zooming routine.								*)
(******************************************************************)
PROCEDURE Zoom2x();
BEGIN
   IF NOT(zoom2x) THEN
      MsgCanvas(13,dummy);
   END;
END Zoom2x;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* zooming routine.								*)
(******************************************************************)
PROCEDURE Zoom3x();
BEGIN
   IF NOT(zoom3x) THEN
      MsgCanvas(14,dummy);
   END;
END Zoom3x;

(******************************************************************)
(* This procedure exits the program.					*)
(******************************************************************)
PROCEDURE DoExit();
BEGIN
   IF NOT(modified) THEN
	Crash("PaintMagic - Version 1.0 Copyright 1997 Matt Ma");
   ELSE
	Beep();
	Exit();
   END;
END DoExit;


(******************************************************************)
(* This procedure notifies the canvas task that the Cut command	*)
(* has been issued.								*)
(******************************************************************)
PROCEDURE DoCut();
BEGIN
   MsgCanvas(15,dummy);
END DoCut;


(******************************************************************)
(* This procedure carries out the BrightnessControl routine.	*)
(******************************************************************)
PROCEDURE DoBrightness();
VAR
   temp : LONGREAL;
BEGIN
   temp := BrightnessInput();
   IF temp >= 0.0 THEN
	BrightnessControl(temp);
   END;
END DoBrightness;

(******************************************************************)
(* This procedure carries out the Write256BMP routine.		*)
(******************************************************************)
PROCEDURE DoSaveBMP();
BEGIN
   SaveFileAs(SaveBmp,FALSE);
END DoSaveBMP;

(******************************************************************)
(* This procedure carries out the Write256PCX routine.		*)
(******************************************************************)
PROCEDURE DoSavePCX();
BEGIN
   SaveFileAs(SavePcx,FALSE);
END DoSavePCX;

(******************************************************************)
(* This procedure carries out the Write256TGA routine.		*)
(******************************************************************)
PROCEDURE DoSaveTGA();
BEGIN
   SaveFileAs(SaveTga,FALSE);
END DoSaveTGA;

(******************************************************************)
(* This procedure carries out the Write256RAW routine.		*)
(******************************************************************)
PROCEDURE DoSaveRAW();
BEGIN
   SaveFileAs(SaveRaw,FALSE);
END DoSaveRAW;

(******************************************************************)
(* This procedure carries out the Write256TIF routine.		*)
(******************************************************************)
PROCEDURE DoSaveTIF();
BEGIN
   SaveFileAs(SaveTif,FALSE);
END DoSaveTIF;

(******************************************************************)
(* This procedure calls the AboutPaintMagic routine.			*)
(******************************************************************)
PROCEDURE About();
BEGIN
   AboutPaintMagic();
END About;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* CropImage routine.								*)
(******************************************************************)
PROCEDURE DoCrop();
BEGIN
   IF IsMarquee THEN
      MsgCanvas(10,dummy);
   END;
END DoCrop;

(******************************************************************)
(* This procedure turns on the show co-ordinate option.		*)
(******************************************************************)
PROCEDURE OrdinateOn();
BEGIN
   ShowOrdinate := TRUE;
END OrdinateOn;

(******************************************************************)
(* This procedure turns off the show co-ordinate option.		*)
(******************************************************************)
PROCEDURE OrdinateOff();
BEGIN
   ShowOrdinate := FALSE;
   ClearStatusBar();
END OrdinateOff;

(******************************************************************)
(* This procedure notifies the canvas task to carry out the		*)
(* CountColour routine.								*)
(******************************************************************)
PROCEDURE ColourCount();
BEGIN
      MsgCanvas(11,dummy);
END ColourCount;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a BMP	*)
(* format image to a PCX format image.					*)
(******************************************************************)
PROCEDURE ConvertBmpToPcx();
BEGIN
   Convert(Bmp,Pcx);
END ConvertBmpToPcx;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a BMP	*)
(* format image to a TGA format image.					*)
(******************************************************************)
PROCEDURE ConvertBmpToTga();
BEGIN
   Convert(Bmp,Tga);
END ConvertBmpToTga;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a BMP	*)
(* format image to a TIF format image.					*)
(******************************************************************)
PROCEDURE ConvertBmpToTif();
BEGIN
   Convert(Bmp,Tif);
END ConvertBmpToTif;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a BMP	*)
(* format image to a RAW data format.					*)
(******************************************************************)
PROCEDURE ConvertBmpToRaw();
BEGIN
   Convert(Bmp,Raw);
END ConvertBmpToRaw;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a PCX	*)
(* format image to a BMP format image.					*)
(******************************************************************)
PROCEDURE ConvertPcxToBmp();
BEGIN
   Convert(Pcx,Bmp);
END ConvertPcxToBmp;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a PCX	*)
(* format image to a TGA format image.					*)
(******************************************************************)
PROCEDURE ConvertPcxToTga();
BEGIN
   Convert(Pcx,Tga);
END ConvertPcxToTga;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a PCX	*)
(* format image to a TIF format image.					*)
(******************************************************************)
PROCEDURE ConvertPcxToTif();
BEGIN
   Convert(Pcx,Tif);
END ConvertPcxToTif;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a PCX	*)
(* format image to a RAW data format.					*)
(******************************************************************)
PROCEDURE ConvertPcxToRaw();
BEGIN
   Convert(Pcx,Raw);
END ConvertPcxToRaw;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TGA	*)
(* format image to a BMP format image.					*)
(******************************************************************)
PROCEDURE ConvertTgaToBmp();
BEGIN
   Convert(Tga,Bmp);
END ConvertTgaToBmp;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TGA	*)
(* format image to a PCX format image.					*)
(******************************************************************)
PROCEDURE ConvertTgaToPcx();
BEGIN
   Convert(Tga,Pcx);
END ConvertTgaToPcx;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TGA	*)
(* format image to a TIF format image.					*)
(******************************************************************)
PROCEDURE ConvertTgaToTif();
BEGIN
   Convert(Tga,Tif);
END ConvertTgaToTif;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TGA	*)
(* format image to a RAW data format.					*)
(******************************************************************)
PROCEDURE ConvertTgaToRaw();
BEGIN
   Convert(Tga,Raw);
END ConvertTgaToRaw;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TIF	*)
(* format image to a BMP format image.					*)
(******************************************************************)
PROCEDURE ConvertTifToBmp();
BEGIN
   Convert(Tif,Bmp);
END ConvertTifToBmp;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TIF	*)
(* format image to a PCX format image.					*)
(******************************************************************)
PROCEDURE ConvertTifToPcx();
BEGIN
   Convert(Tif,Pcx);
END ConvertTifToPcx;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TIF	*)
(* format image to a TGA format image.					*)
(******************************************************************)
PROCEDURE ConvertTifToTga();
BEGIN
   Convert(Tif,Tga);
END ConvertTifToTga;

(******************************************************************)
(* This procedure calls the Convert procedure to convert a TIF	*)
(* format image to a RAW data format.					*)
(******************************************************************)
PROCEDURE ConvertTifToRaw();
BEGIN
   Convert(Tif,Raw);
END ConvertTifToRaw;

(******************************************************************)
(* This procedure draws the menu buttons.					*)
(******************************************************************)
PROCEDURE DrawMenuButtons();
VAR
   MenuButton, SubMenu1, SubMenu2, SubMenu3, SubMenu4, SubMenu5,
   SubMenu6, SubMenu7, SubMenu8, SubMenu9 : BoxMenuTYPE;
   MenuList:BoxMenuItemTYPE;
BEGIN

   (*********************************************)
   (* draws the Convert submenu buttons.		*)
   (*********************************************)
   SubMenu6 := CreateBoxSubMenu("bmp_to",TRUE,1,4+4,0+8,7,2,3+18,0+136+5+109,0+113-16,1,7+1-4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu6,TRUE,TRUE,"PCX     P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertBmpToPcx);
   MenuList := BoxSubMenuItemSetup(SubMenu6,TRUE,TRUE,"TGA     T",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertBmpToTga);
   MenuList := BoxSubMenuItemSetup(SubMenu6,TRUE,TRUE,"TIF     F",NoIconDraw,0,0,3,15-7,NoSubMenu,TRUE,ConvertBmpToTif);
   MenuList := BoxSubMenuItemSetup(SubMenu6,TRUE,TRUE,"RAW     R",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertBmpToRaw);

   SubMenu7 := CreateBoxSubMenu("pcx_to",TRUE,1,4+4,0+8,7,2,3+18,0+136+5+109,0+113+1,1,7+1-4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu7,TRUE,TRUE,"BMP     B",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertPcxToBmp);
   MenuList := BoxSubMenuItemSetup(SubMenu7,TRUE,TRUE,"TGA     T",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertPcxToTga);
   MenuList := BoxSubMenuItemSetup(SubMenu7,TRUE,TRUE,"TIF     F",NoIconDraw,0,0,3,15-7,NoSubMenu,TRUE,ConvertPcxToTif);
   MenuList := BoxSubMenuItemSetup(SubMenu7,TRUE,TRUE,"RAW     R",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertPcxToRaw);

   SubMenu8 := CreateBoxSubMenu("tga_to",TRUE,1,4+4,0+8,7,2,3+18,0+136+5+109,0+113+17,1,7+1-4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu8,TRUE,TRUE,"BMP     B",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTgaToBmp);
   MenuList := BoxSubMenuItemSetup(SubMenu8,TRUE,TRUE,"PCX     P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTgaToPcx);
   MenuList := BoxSubMenuItemSetup(SubMenu8,TRUE,TRUE,"TIF     F",NoIconDraw,0,0,3,15-7,NoSubMenu,TRUE,ConvertTgaToTif);
   MenuList := BoxSubMenuItemSetup(SubMenu8,TRUE,TRUE,"RAW     R",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTgaToRaw);

   SubMenu9 := CreateBoxSubMenu("tif_to",TRUE,1,4+4,0+8,7,2,3+18,0+136+5+109,0+113+33,1,7+1-4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu9,TRUE,TRUE,"BMP     B",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTifToBmp);
   MenuList := BoxSubMenuItemSetup(SubMenu9,TRUE,TRUE,"PCX     P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTifToPcx);
   MenuList := BoxSubMenuItemSetup(SubMenu9,TRUE,TRUE,"TGA     T",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTifToTga);
   MenuList := BoxSubMenuItemSetup(SubMenu9,TRUE,TRUE,"RAW     R",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ConvertTifToRaw);

   SubMenu1 := CreateBoxSubMenu("convert",TRUE,1,4+4,0+8,7,2,3+18,0+136+5,0+113-16,1,7+1-4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu1,TRUE,TRUE,"BMP To...  ",NoIconDraw,0,0,1,15-7,SubMenu6,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(SubMenu1,TRUE,TRUE,"PCX To...  ",NoIconDraw,0,0,1,15-7,SubMenu7,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(SubMenu1,TRUE,TRUE,"TGA To...  ",NoIconDraw,0,0,1,15-7,SubMenu8,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(SubMenu1,TRUE,TRUE,"TIF To...  ",NoIconDraw,0,0,3,15-7,SubMenu9,TRUE,Dummy);

   (*********************************************)
   (* draws the Save As submenu buttons.		*)
   (*********************************************)
   SubMenu2 := CreateBoxSubMenu("save_as",TRUE,1,4+4,0+8,7,2,3+18,0+136+5,0+113-64,1,7+1-2,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"Bitmap     B",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoSaveBMP);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"PCX        P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoSavePCX);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"Targa      T",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoSaveTGA);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"TIFF       F",NoIconDraw,0,0,3,15-7,NoSubMenu,TRUE,DoSaveTIF);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"Raw        R",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoSaveRAW);
   MenuList := BoxSubMenuItemSetup(SubMenu2,TRUE,TRUE,"GIF        G",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Dummy);

   (*********************************************)
   (* draws the Capture submenu buttons.		*)
   (*********************************************)
   SubMenu3 := CreateBoxSubMenu("screen",TRUE,1,4+4,0+8,7,2,3+18,479+8,66-18,1,7+1-6,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu3,TRUE,TRUE,"Show Cursor   S",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,CaptFileName1);
   MenuList := BoxSubMenuItemSetup(SubMenu3,TRUE,TRUE,"Hide Cursor   H",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,CaptFileName2);

   SubMenu4 := CreateBoxSubMenu("capture",TRUE,1,4+4,0+8,7,2,3+18,378,49-1,1,7+1-7,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu4,TRUE,TRUE,"Screen...  ",NoIconDraw,0,0,1,15-7,SubMenu3,TRUE,Dummy);

   SubMenu5 := CreateBoxSubMenu("ordinate",TRUE,1,4+4,0+8,7,2,3+18,479+8-180,66+14,1,7+1-6,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(SubMenu5,TRUE,TRUE,"On       O",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,OrdinateOn);
   MenuList := BoxSubMenuItemSetup(SubMenu5,TRUE,TRUE,"Off      F",NoIconDraw,0,0,2,15-7,NoSubMenu,TRUE,OrdinateOff);

   (*********************************************)
   (* draws the File menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("File     ",TRUE,1,4+4,0+8,7,2,3+18,0,0,1,7+2-1,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"New            N",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,NewImage);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Open...        O",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoOpen);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Save           S",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,SaveFile);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Save As...     ",NoIconDraw,0,0,6,15-7,SubMenu2,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Delete...      D",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DeleteFile);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Change Path    P",NoIconDraw,0,0,8,15-7,NoSubMenu,TRUE,ChangePath);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Convert...     ",NoIconDraw,0,0,1,15-7,SubMenu1,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Exit           X",NoIconDraw,0,0,2,15-7,NoSubMenu,TRUE,DoExit);
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the Edit menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("Edit     ",TRUE,1,4+4,0+8,7,86+3,3+18,0,0,1,4-1,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Undo       U",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Copy       Y",NoIconDraw,0,0,4,15-7,NoSubMenu,TRUE,Dummy);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Cut        C",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoCut);
   (*MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Paste      P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Dummy);*)
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the File menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("View     ",TRUE,1,4+4,0+8,7,172+4,3+18,0,0-0-1,1,4+1+1,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"1:1           1",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,NormalView);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"2:1           2",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Zoom2x);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"3:1           3",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Zoom3x);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Palette       P",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Palette256);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Image Info    I",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ShowImageInfo);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Co-ordinates  ",NoIconDraw,0,0,1,15-7,SubMenu5,TRUE,Dummy);
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the Image menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("Image    ",TRUE,1,4+4,0+8,7,258+5,3+18,0,0,1,4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Flip        F",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Flip);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Mirror      M",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Mirror);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Crop        C",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoCrop);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Capture...  ",NoIconDraw,0,0,2,15-7,SubMenu4,TRUE,Dummy);
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the Colour menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("Colour   ",TRUE,1,4+4,0+8,7,344+6,3+18,0,0,1,4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Invert          I",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Invert);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Brightness      B",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,DoBrightness);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Grey Scale      G",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,GreyScaling);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Count Colours   C",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,ColourCount);
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the Mode menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("Mode     ",TRUE,1,4+4,0+8,7,430+7,3+18,0,0,1,4,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"640x480x256",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Set640x480x256);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"800x600x256",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Set800x600x256);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"1024x768x256",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Set1024x768x256);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"1280x1024x256 ",NoIconDraw,0,0,2,15-7,NoSubMenu,TRUE,Set1280x1024x256);
   DisplayBoxSubMenuTitle(MenuButton);

   (*********************************************)
   (* draws the Help menu button.			*)
   (*********************************************)
   MenuButton := CreateBoxSubMenu("Help     ",TRUE,1,4+4,0+8,7,516+8,3+18,0,0-0-1,1,2,0,0,0,12,1+7,7,Normal,SetFinger);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"Contents   C",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Index);
   MenuList := BoxSubMenuItemSetup(MenuButton,TRUE,TRUE,"About...   A",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,About);
   DisplayBoxSubMenuTitle(MenuButton);


   Line(86+4,YMAX-43,86+4,YMAX-20,7);
   Line(86+2,YMAX-44,86+2,YMAX-20,15);
   Line(86+2,YMAX-44,86+3,YMAX-44,15);
   Line(86+3,YMAX-19,86+4,YMAX-19,8+5);
   Line(86+2,YMAX-18,86+4,YMAX-18,8+5);

END DrawMenuButtons;

(******************************************************************)
(* This procedure draws the zoom control box.				*)
(******************************************************************)
PROCEDURE DrawZoomBox();
VAR
  x_offset, y_offset : CARDINAL;
  ZoomBox : BoxMenuTYPE;
  ZoomFactor : BoxMenuItemTYPE;
BEGIN
   ZoomBox := CreateBoxSubMenu(CHR(31),TRUE,1,4+4,0+8,7,344+6+30,3+18+32,0-45,0+1+1,1,4-1,0,0,0,12,1+7,7,Normal,SetFinger);
   ZoomFactor := BoxSubMenuItemSetup(ZoomBox,TRUE,TRUE,"1:1 ",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,NormalView);
   ZoomFactor := BoxSubMenuItemSetup(ZoomBox,TRUE,TRUE,"2:1 ",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Zoom2x);
   ZoomFactor := BoxSubMenuItemSetup(ZoomBox,TRUE,TRUE,"3:1 ",NoIconDraw,0,0,1,15-7,NoSubMenu,TRUE,Zoom3x);
   DisplayBoxSubMenuTitle(ZoomBox);

   x_offset := 344+6-44+30;
   y_offset := 3+18+32-2;

   Line(0+x_offset,0+y_offset,0+x_offset,0+y_offset+24-1,8-8);
   Line(0+x_offset,0+y_offset,0+x_offset+65,0+y_offset,8-8);
   Line(1+x_offset,1+y_offset+1,1+x_offset,1+y_offset+21,0+8);
   Line(1+x_offset,1+y_offset,1+x_offset+63,1+y_offset,0+8);
   Line(0+x_offset,24+y_offset,66+x_offset,24+y_offset,15);
   Line(66+x_offset,24+y_offset,66+x_offset,0+y_offset,15);

   Rectangle(2+x_offset,2+y_offset,1+x_offset+38-1+5,22+y_offset,15,TRUE);

   DisplayString("1:1",344+6-39+0+30,3+18+32-2+5,8,FALSE);
END DrawZoomBox;

(******************************************************************)
(* Initialisations.								*)
(******************************************************************)
BEGIN
   option := 0;
END Bars.