IMPLEMENTATION MODULE FileRoutines;

(******************************************************************)
(*											*)
(*			  File Handling Routines Module			*)
(*											*)
(*	Programmer :	Matthew Ma (c9315720)				*)
(*											*)
(*	Last edited :	22-10-97						*)
(*											*)
(*	Function : 		This module contains some file handling	*)
(*				routines.						*)
(*											*)
(*	Status :		Working.						*)
(******************************************************************)


IMPORT ColourRoutines;

FROM WriteBMP IMPORT
(* proc *)   Write256BMP;

FROM WritePCX IMPORT
(* proc *)   Write256PCX;

FROM WriteTGA IMPORT
(* proc *)   Write256TGA;

FROM WriteRAW IMPORT
(* proc *)   WriteRawData;

FROM Canvas IMPORT
(* var  *)   CanvasLeft, CanvasTop, CanvasRight, CanvasBottom,
(* proc *)   MsgCanvas;

FROM InfoDialogs IMPORT
(* proc *)   FileNotFound, FileExists, FileModified, UnknownFormat,
		 PathNotFound, InvalidInput, ConfirmDelete;

FROM FIOR IMPORT
(* proc *)   IsExtension, ChangeExtension;

IMPORT FIO, FIOR;

FROM BmpToPcx IMPORT
(* proc *)   Bmp256ToPcx256;

FROM BmpToTga IMPORT
(* proc *)   Bmp256ToTga256;

FROM BmpToTif IMPORT
(* proc *)   Bmp256ToTif256;

FROM BmpToRaw IMPORT
(* proc *)   Bmp256ToRawData;

FROM TgaToBmp IMPORT
(* proc *)   Tga256ToBmp256;

FROM TgaToPcx IMPORT
(* proc *)   Tga256ToPcx256;

FROM TgaToTif IMPORT
(* proc *)   Tga256ToTif256;

FROM TgaToRaw IMPORT
(* proc *)   Tga256ToRawData;

FROM PcxToTif IMPORT
(* proc *)   Pcx256ToTif256;

FROM PcxToRaw IMPORT
(* proc *)   Pcx256ToRawData;

FROM TifToBmp IMPORT
(* proc *)   Tif256ToBmp256;

FROM TifToTga IMPORT
(* proc *)   Tif256ToTga256;

FROM TifToPcx IMPORT
(* proc *)   Tif256ToPcx256;

FROM TifToRaw IMPORT
(* proc *)   Tif256ToRawData;

FROM Bars IMPORT
(* proc *)   UpdateStatusBar;

FROM GraphicWindow IMPORT
(* var  *)   CharWidth, CharHeight, XMAX, YMAX,
(* type *)	 ColourType, GraphicalWindow,
(* proc *)	 CreateGraphicalWindow, PutRectangle, DataRegionDisplayed,
        	 DisplayWindowData, HideWindowData, PutString, PutTitleStrip,
        	 ObtainScreen, ReleaseScreen, DoNothing, PutChar, ReturnDataLeftTop;

FROM TaskControl IMPORT
(* type *)   Lock,
(* proc *)   CreateTask, CreateLock, Obtain, Release;

FROM Dialogs IMPORT
(* type *)	 Dialog, DialogType, DialogStringPointer, OtherInputType,
(* proc *)	 CreateDialog, AddABox, DisplayDialog, DialogWindow, StuffSelection,
        	 MoveDialogABS, SetOtherInput, EndCreateDialog, HideDialog, DialogSelection;

FROM Str IMPORT
(* proc *)	 Copy, Length, CharPos, Insert, Append, Caps, StrToReal;

FROM SoundEffects IMPORT
(* proc *)   Beep;


CONST
   NULL = CHR(0);
   MaxFileNameLength = 12;
   MaxPathLength = 60;
   dummy = 123;
   null = CHR(0);


TYPE
   FileNameTYPE = ARRAY [0..12] OF CHAR;
   PathNameTYPE = ARRAY [0..60] OF CHAR;


VAR
   file_dialog, path_dialog : Dialog;
   drive : SHORTCARD;
   dummy999 : LongStr;



(******************************************************************)
(* This procedure checks whether the file extension is a valid	*)
(* one.										*)
(******************************************************************)
PROCEDURE ValidExtension(file_name : ARRAY OF CHAR) : BOOLEAN;
BEGIN
   IF (IsExtension(file_name,"BMP")) THEN
      extension := Bmp;
      RETURN TRUE;
   ELSIF
      (IsExtension(file_name,"PCX")) THEN
      extension := Pcx;
      RETURN TRUE;
   ELSIF
      (IsExtension(file_name,"TGA")) THEN
      extension := Tga;
      RETURN TRUE;
   ELSIF
      (IsExtension(file_name,"TIF")) THEN
      extension := Tif;
      RETURN TRUE;
   (*ELSIF
      (IsExtension(file_name,"GIF")) THEN
      extension := Gif;
      RETURN TRUE;
   ELSIF
      (IsExtension(file_name,"JPG")) THEN
      extension := Jpg;
      RETURN TRUE;*)
   ELSE
      RETURN FALSE;
   END;
END ValidExtension;


(******************************************************************)
(* This procedure reads the dialog text input string.			*)
(******************************************************************)
PROCEDURE GetString(action : Actions; str_ptr : DialogStringPointer; width:INTEGER;
                    str_leng : INTEGER; string : LongStrPtr; x_offset,y_offset : INTEGER) : BOOLEAN;
VAR
   ok:BOOLEAN;
BEGIN
   SetOtherInput(file_dialog,1,String,x_offset,y_offset+2*CharHeight,0,0,width, str_leng,1+7);

   DisplayDialog(file_dialog, TRUE);

   IF (ObtainScreen()) THEN
      CASE action OF
		  New:
    			PutTitleStrip(DialogWindow(file_dialog),"New Image");
		| Open:
			PutTitleStrip(DialogWindow(file_dialog),"Open");
		| SaveBmp:
			PutTitleStrip(DialogWindow(file_dialog),"Save BMP");
		| SavePcx:
			PutTitleStrip(DialogWindow(file_dialog),"Save PCX");
		| SaveTga:
			PutTitleStrip(DialogWindow(file_dialog),"Save TGA");
		| SaveTif:
			PutTitleStrip(DialogWindow(file_dialog),"Save TIF");
		| SaveRaw:
			PutTitleStrip(DialogWindow(file_dialog),"Save RAW");
		| Delete:
			PutTitleStrip(DialogWindow(file_dialog),"Delete");
		| Brightness:
			PutTitleStrip(DialogWindow(file_dialog),"Brightness");
		| CaptShow:
			PutTitleStrip(DialogWindow(file_dialog),"Capture Screen");
		| CaptHide:
			PutTitleStrip(DialogWindow(file_dialog),"Capture Screen");
		| Bmp2Pcx:
			PutTitleStrip(DialogWindow(file_dialog),"BMP To PCX");
		| Bmp2Tga:
			PutTitleStrip(DialogWindow(file_dialog),"BMP To TGA");
		| Bmp2Tif:
			PutTitleStrip(DialogWindow(file_dialog),"BMP To TIF");
		| Bmp2Raw:
			PutTitleStrip(DialogWindow(file_dialog),"BMP To RAW");
		| Pcx2Bmp:
			PutTitleStrip(DialogWindow(file_dialog),"PCX To BMP");
		| Pcx2Tga:
			PutTitleStrip(DialogWindow(file_dialog),"PCX To TGA");
		| Pcx2Tif:
			PutTitleStrip(DialogWindow(file_dialog),"PCX To TIF");
		| Pcx2Raw:
			PutTitleStrip(DialogWindow(file_dialog),"PCX To RAW");
		| Tga2Bmp:
			PutTitleStrip(DialogWindow(file_dialog),"TGA To BMP");
		| Tga2Pcx:
			PutTitleStrip(DialogWindow(file_dialog),"TGA To PCX");
		| Tga2Tif:
			PutTitleStrip(DialogWindow(file_dialog),"TGA To TIF");
		| Tga2Raw:
			PutTitleStrip(DialogWindow(file_dialog),"TGA To Raw");
		| Tif2Bmp:
			PutTitleStrip(DialogWindow(file_dialog),"TIF To BMP");
		| Tif2Pcx:
			PutTitleStrip(DialogWindow(file_dialog),"TIF To PCX");
		| Tif2Tga:
			PutTitleStrip(DialogWindow(file_dialog),"TIF To TGA");
		| Tif2Raw:
			PutTitleStrip(DialogWindow(file_dialog),"TIF To RAW");
		ELSE
	END;
   	PutString(DialogWindow(file_dialog),string^,3+2,y_offset+2*CharHeight,1+7,FALSE);
   	ReleaseScreen();
   END;(*IF*)

   ok := (DialogSelection(file_dialog,str_ptr) = 1);

   HideDialog(file_dialog);

   Caps(str_ptr^[0]);

   RETURN (ok);
END GetString;


(******************************************************************)
(* This procedure reads the full path from the dailog text input.	*)
(******************************************************************)
PROCEDURE GetPathName(str_ptr : DialogStringPointer; width : INTEGER; str_leng : INTEGER;
                      string : LongStrPtr; x_offset,y_offset : INTEGER) : BOOLEAN;
VAR
  ok:BOOLEAN;
BEGIN
   SetOtherInput(path_dialog,1,String,x_offset,y_offset+CharHeight,0,0,width, str_leng,1+7);

   DisplayDialog(path_dialog, TRUE);

   IF (ObtainScreen()) THEN
   	PutTitleStrip(DialogWindow(path_dialog),"Change Path");
    	PutString(DialogWindow(path_dialog),string^,3,y_offset+CharHeight,1+7,FALSE);
    	ReleaseScreen();
   END; (* IF *)

  ok := (DialogSelection(path_dialog,str_ptr) = 1);

  HideDialog(path_dialog);

  RETURN (ok);
END GetPathName;


(******************************************************************)
(* This procedure creates a new image on the canvas.			*)
(******************************************************************)
PROCEDURE NewImage();
BEGIN
   new_image := TRUE;
   IF NOT(modified) THEN
	MsgCanvas(3,0);

	(***********************************)
	(* initialises palette with values *)
	(* stored in the Default.PAL file  *)
	(***********************************)
	ColourRoutines.Initialise();
   ELSE

	(************************************)
	(* indicates file has been modified *)
	(************************************)
	Beep();
	FileModified();
   END;
END NewImage;


(******************************************************************)
(* This procedure opens an image file.					*)
(******************************************************************)
PROCEDURE OpenFile();
VAR
   i : CARDINAL;
   file_name : FileNameTYPE;
   ok : BOOLEAN;
BEGIN
   FOR i := 0 TO 12 DO
	 file_name[i] := null;
   END;

   ok := GetString(Open,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);

   IF ok THEN
	IF FIO.Exists(file_name) THEN
	   IF ValidExtension(file_name) THEN
	   	Copy(OpenFileName, file_name);
	   	MsgCanvas(6,dummy);
	   ELSE
		Beep();
		UnknownFormat();
	   END;
	ELSE
	   Beep();
	   FileNotFound();
	END;
   END;
	
END OpenFile;


(******************************************************************)
(* This procedure saves a screen image to an existing file. If	*)
(* the file does not exist, SaveFileAs will be called.		*)
(******************************************************************)
PROCEDURE SaveFile();
BEGIN
   IF extension <> Untitled THEN
	MsgCanvas(7,99);
   ELSE
	SaveFileAs(SaveBmp,FALSE);
   END;
END SaveFile;


(******************************************************************)
(* This procedure overwrites an existing file.				*)
(******************************************************************)
PROCEDURE ReplaceFile(type : Actions; file_name : ARRAY OF CHAR);
BEGIN
   FIO.Erase(file_name);
   CASE type OF
	  SaveBmp:
		Write256BMP(CanvasLeft,CanvasTop,CanvasRight,CanvasBottom,file_name);
		modified := FALSE;

	| SavePcx:
		Write256PCX(CanvasLeft,CanvasTop,CanvasRight,CanvasBottom,file_name,FALSE);
		modified := FALSE;

	| SaveTga:
		Write256TGA(CanvasLeft,CanvasTop,CanvasRight,CanvasBottom,file_name);
		modified := FALSE;

	| SaveRaw:
		WriteRawData(CanvasLeft,CanvasTop,CanvasRight,CanvasBottom,file_name);
		modified := FALSE;

	ELSE
   END;
END ReplaceFile;


(******************************************************************)
(* This procedure saves a screen image to a file.			*)
(******************************************************************)
PROCEDURE SaveFileAs(type : Actions; replace : BOOLEAN);
VAR
   i : CARDINAL;
   file_name : FileNameTYPE;
   save : BOOLEAN;
BEGIN
   FOR i := 0 TO 12 DO
	 file_name[i] := null;
   END;

   CASE type OF
	  SaveBmp:
    		save := GetString(SaveBmp,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);
		ChangeExtension(file_name,"BMP");
		Copy(SaveAsFileName, file_name);

	| SavePcx:
		save := GetString(SavePcx,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);
		ChangeExtension(file_name,"PCX");
		Copy(SaveAsFileName, file_name);

	| SaveTga:
		save := GetString(SaveTga,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);
		ChangeExtension(file_name,"TGA");
		Copy(SaveAsFileName, file_name);

	| SaveTif:
		save := GetString(SaveTif,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);
		ChangeExtension(file_name,"TIF");
		Copy(SaveAsFileName, file_name);

	| SaveRaw:
		save := GetString(SaveRaw,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,10);
		ChangeExtension(file_name,"RAW");
		Copy(SaveAsFileName, file_name);

	ELSE
   END;
	

   IF save THEN
	CASE type OF
		  SaveBmp:
			format := SaveBmp;
			IF NOT(FIO.Exists(SaveAsFileName)) THEN
			   MsgCanvas(22,dummy);
			ELSE
			   Beep();
			   FileExists(SaveBmp,SaveAsFileName);
			END;

		| SavePcx:
			format := SavePcx;
			IF NOT(FIO.Exists(SaveAsFileName)) THEN
			   MsgCanvas(22,dummy);
			ELSE
			   Beep();
			   FileExists(SavePcx,SaveAsFileName);
			END;

		| SaveTga:
			format := SaveTga;
			IF NOT(FIO.Exists(SaveAsFileName)) THEN
			   MsgCanvas(22,dummy);
			ELSE
			   Beep();
			   FileExists(SaveTga,SaveAsFileName);
			END;

		| SaveTif:
			format := SaveTif;
			IF NOT(FIO.Exists(SaveAsFileName)) THEN
			   MsgCanvas(22,dummy);
			ELSE
			   Beep();
			   FileExists(SaveTif,SaveAsFileName);
			END;

		| SaveRaw:
			format := SaveRaw;
			IF NOT(FIO.Exists(SaveAsFileName)) THEN
			   MsgCanvas(22,dummy);
			ELSE
			   Beep();
			   FileExists(SaveRaw,SaveAsFileName);
			END;

		ELSE
	   END;
      END;
	
END SaveFileAs;


(******************************************************************)
(* This procedure changes the current path.				*)
(******************************************************************)
PROCEDURE ChangePath();
VAR
   i : CARDINAL;
   ok : BOOLEAN;
   path_name : PathNameTYPE;
BEGIN
   FOR i := 0 TO 60 DO
	 path_name[i] := null;
   END;

   ok := GetPathName(ADR(path_name),MaxPathLength,HIGH(path_name),ADR("Path: "),11*CharWidth-40,10);

   (*IF NOT(FIO.IOcheck) THEN*)
      FIO.ChDir(path_name);
   (*ELSE*)

   IF (FIO.IOcheck) THEN
	(* path not found *)
	Beep();
	PathNotFound();
   END;
END ChangePath;


(******************************************************************)
(* This procedure deletes an existing file.				*)
(******************************************************************)
PROCEDURE DeleteFile();
VAR
   i : CARDINAL;
   ok : BOOLEAN;
   file_name : FileNameTYPE;
BEGIN
   FOR i := 0 TO 11 DO
	 file_name[i] := null;
   END;
   ok := GetString(Delete,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,5+5);

   IF ok THEN
      IF NOT(FIO.Exists(file_name)) THEN
	   Beep();
	   FileNotFound();
      ELSE
	   (*FIO.Erase(file_name);*)
	   ConfirmDelete(file_name);
      END;
   END;
END DeleteFile;


(******************************************************************)
(* This procedure carries out the image file format conversion.	*)
(******************************************************************)
PROCEDURE Convert(input,output : FileTypes);
VAR
   i, error : CARDINAL;
   ok : BOOLEAN;
   in_file, out_file : FileNameTYPE;
BEGIN
   FOR i := 0 TO 12 DO
	 in_file[i] := null;
   END;

   IF (input = Bmp) AND (output = Pcx) THEN
   	ok := GetString(Bmp2Pcx,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"BMP");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"PCX");
		error := Bmp256ToPcx256(in_file,out_file);
         END;
      END;
   ELSIF (input = Bmp) AND (output = Tga) THEN
	ok := GetString(Bmp2Tga,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"BMP");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"TGA");
		error := Bmp256ToTga256(in_file,out_file);
         END;
      END;
   ELSIF (input = Bmp) AND (output = Tif) THEN
	ok := GetString(Bmp2Tif,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"BMP");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"TIF");
		error := Bmp256ToTif256(in_file,out_file);
         END;
      END;
   ELSIF (input = Bmp) AND (output = Raw) THEN
	ok := GetString(Bmp2Raw,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"BMP");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"RAW");
		error := Bmp256ToRawData(in_file,out_file);
         END;
      END;
   ELSIF (input = Pcx) AND (output = Bmp) THEN
	ok := GetString(Pcx2Bmp,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
   ELSIF (input = Pcx) AND (output = Tga) THEN
	ok := GetString(Pcx2Tga,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
   ELSIF (input = Pcx) AND (output = Tif) THEN
	ok := GetString(Pcx2Tif,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"PCX");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"TIF");
		error := Pcx256ToTif256(in_file,out_file);
         END;
      END;
   ELSIF (input = Pcx) AND (output = Raw) THEN
	ok := GetString(Pcx2Raw,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"PCX");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"RAW");
		error := Pcx256ToRawData(in_file,out_file);
         END;
      END;
   ELSIF (input = Tga) AND (output = Bmp) THEN
	ok := GetString(Tga2Bmp,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TGA");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"BMP");
		error := Tga256ToBmp256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tga) AND (output = Pcx) THEN
	ok := GetString(Tga2Pcx,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TGA");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"PCX");
		error := Tga256ToPcx256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tga) AND (output = Tif) THEN
	ok := GetString(Tga2Tif,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TGA");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"TIF");
		error := Tga256ToTif256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tga) AND (output = Raw) THEN
	ok := GetString(Tga2Raw,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TGA");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"RAW");
		error := Tga256ToRawData(in_file,out_file);
         END;
      END;
   ELSIF (input = Tif) AND (output = Bmp) THEN
	ok := GetString(Tif2Bmp,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TIF");
      IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"BMP");
		error := Tif256ToBmp256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tif) AND (output = Pcx) THEN
	ok := GetString(Tif2Pcx,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TIF");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"PCX");
		error := Tif256ToPcx256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tif) AND (output = Tga) THEN
	ok := GetString(Tif2Tga,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TIF");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"TGA");
		error := Tif256ToTga256(in_file,out_file);
         END;
      END;
   ELSIF (input = Tif) AND (output = Raw) THEN
	ok := GetString(Tif2Raw,ADR(in_file),MaxFileNameLength,HIGH(in_file),ADR("File Name: "),11*CharWidth+5,5+5);
	ChangeExtension(in_file,"TIF");
	IF ok THEN
         IF NOT(FIO.Exists(in_file)) THEN
		Beep();
	      FileNotFound();
         ELSE
	      Copy(out_file,in_file);
		ChangeExtension(out_file,"RAW");
		error := Tif256ToRawData(in_file,out_file);
         END;
      END;
   ELSE
   END;

END Convert;


(******************************************************************)
(* This procedure reads the brightness control input and returns	*)
(* the value as a LONGREAL number.						*)
(******************************************************************)
PROCEDURE BrightnessInput() : LONGREAL;
VAR
   i : CARDINAL;
   ok, valid : BOOLEAN;
   factor : LONGREAL;
   string : ARRAY [0..9] OF CHAR;
BEGIN
   FOR i := 0 TO 9 DO
	 string[i] := null;
   END;
   ok := GetString(Brightness,ADR(string),MaxFileNameLength,HIGH(string),ADR("Factor: "),8*CharWidth+5,10);

   IF ok THEN
      factor := StrToReal(string,valid);
	IF valid THEN
	   modified := TRUE;
	   RETURN (factor);
	ELSE
	   (* InvalidInput *)
	   Beep();
	   InvalidInput();
	   RETURN (-1.0);
	END;
   ELSE
	RETURN (-1.0);
   END;
END BrightnessInput;


(******************************************************************)
(* This procedure reads the input file file name under which the	*)
(* captured image (with cursor) will be saved.				*)
(******************************************************************)
PROCEDURE CaptFileName1();
VAR
   i : CARDINAL;
   ok : BOOLEAN;
   file_name : FileNameTYPE;
BEGIN
   FOR i := 0 TO 12 DO
	 file_name[i] := null;
   END;

   ok := GetString(CaptShow,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,5+5);
   ChangeExtension(file_name,"PCX");

   IF ok THEN
	format := CaptShow;
	Copy(CaptName, file_name);
	IF NOT(FIO.Exists(file_name)) THEN
	   (*Copy(CaptName, file_name);*)
	   MsgCanvas(23-1,dummy);
	ELSE
	   Beep();
	   FileExists(CaptShow,CaptName);
	END;
   END;
END CaptFileName1;


(******************************************************************)
(* This procedure reads the input file file name under which the	*)
(* captured image (without cursor) will be saved.			*)
(******************************************************************)
PROCEDURE CaptFileName2();
VAR
   i : CARDINAL;
   ok : BOOLEAN;
   file_name : FileNameTYPE;
BEGIN
   FOR i := 0 TO 12 DO
	 file_name[i] := null;
   END;

   ok := GetString(CaptHide,ADR(file_name),MaxFileNameLength,HIGH(file_name),ADR("File Name: "),11*CharWidth+5,5+5);
   ChangeExtension(file_name,"PCX");

   IF ok THEN
	format := CaptHide;
	Copy(CaptName, file_name);
	IF NOT(FIO.Exists(file_name)) THEN
	   (*Copy(CaptName, file_name);*)
	   MsgCanvas(24-2,dummy);
	ELSE
	   Beep();
	   FileExists(CaptHide,CaptName);
	END;
   END;
END CaptFileName2;



(*******************)
(* initialisations *)
(*******************)
BEGIN

   drive := FIO.GetDrive();
   (*FIO.GetDir(drive,path_name);*)

   OpenFileName[0] := NULL;
   FIO.IOcheck := FALSE;

   CreateDialog(file_dialog, NIL,WithOtherInput,1,(XMAX-236-4) DIV 2,(YMAX-80) DIV 2,7,1+7,1+7,FALSE,NIL,
               236+4,80,6*CharWidth+1,CharHeight,38+1,5);
   AddABox(file_dialog,ADR("  Ok"),1+2,15-7,TRUE);
   AddABox(file_dialog,ADR("Cancel"),1,4+4,TRUE);
   EndCreateDialog(file_dialog);

   CreateDialog(path_dialog, NIL,WithOtherInput,1,100-7,100+23+100-30,7,1+7,1+7,FALSE,NIL,
                220+340-24+1,60-20+10,6*CharWidth+1,CharHeight,5,5);
   AddABox(path_dialog,ADR("  Ok"),1+2,15-7,TRUE);
   AddABox(path_dialog,ADR("Cancel"),1,4+4,TRUE);
   EndCreateDialog(path_dialog);

   extension := Untitled;
   modified := FALSE;
   new_image := FALSE;
   open := FALSE;
   Copy(OpenFileName, "untitled");

END FileRoutines.