IMPLEMENTATION MODULE Icons;

(******************************************************************)
(*											*)
(*				    Icons Module					*)
(*											*)
(*	Programmer :	Matthew Ma (c9315720)				*)
(*											*)
(*	Last edited :	22-10-97						*)
(*											*)
(*	Function : 		This module contains all the icon-drawing	*)
(*				routines as well as the icon-positioning	*)
(*				routine.						*)
(* 											*)
(*	Status :		Working.						*)
(******************************************************************)


FROM GraphicWindow IMPORT
(* proc *)   Plot, PutDot, Line, PutLine, Rectangle, PutRectangle, TrueCircle,
             PutCircle, TrueDisc, ColourType;



(******************************************************************)
(* This a near procedure for drawing dots.				*)
(******************************************************************)
PROCEDURE DrawDot(x_offset, y_offset, x, y, colour : INTEGER);
BEGIN
   Plot(x_offset + x, y_offset + y, colour)
END DrawDot;


(******************************************************************)
(* This a near procedure for drawing dots.				*)
(******************************************************************)
PROCEDURE DrawDot2(window : GraphicalWindow; x_offset, y_offset, x, y, colour : INTEGER);
BEGIN
   PutDot(window, x_offset + x, y_offset + y, colour)
END DrawDot2;


(******************************************************************)
(* This a near procedure for drawing lines.				*)
(******************************************************************)
PROCEDURE DrawLine(x_offset, y_offset, x1, y1, x2, y2, colour : INTEGER);
BEGIN
   Line(x_offset + x1, y_offset + y1, x_offset + x2, y_offset + y2, colour);
END DrawLine;


(******************************************************************)
(* This a near procedure for drawing lines.				*)
(******************************************************************)
PROCEDURE DrawLine2(window : GraphicalWindow; x_offset, y_offset,
			  x1, y1, x2, y2, colour : INTEGER);
BEGIN
   PutLine(window, x_offset + x1, y_offset + y1, x_offset + x2, y_offset + y2, colour);
END DrawLine2;


(******************************************************************)
(* This a near procedure for drawing rectangles.			*)
(******************************************************************)
PROCEDURE DrawRectangle(x_offset, y_offset, x1, y1, x2, y2, colour : INTEGER; fill : BOOLEAN);
BEGIN
   Rectangle(x_offset + x1, y_offset + y1, x_offset + x2, y_offset + y2, colour, fill);
END DrawRectangle;


(******************************************************************)
(* This a near procedure for drawing rectangles.			*)
(******************************************************************)
PROCEDURE DrawRectangle2(window : GraphicalWindow; x_offset, y_offset,
				 x1, y1, x2, y2, colour : INTEGER; fill : BOOLEAN);
BEGIN
   PutRectangle(window, x_offset + x1, y_offset + y1, x_offset + x2, y_offset + y2, colour, fill);
END DrawRectangle2;


(******************************************************************)
(* This a near procedure for drawing transparent circles.		*)
(******************************************************************)
PROCEDURE DrawCircle(x_offset, y_offset, x1, y1, r, colour : INTEGER);
BEGIN
   TrueCircle(x_offset + x1, y_offset + y1, r, colour);
END DrawCircle;


(******************************************************************)
(* This a near procedure for drawing transparent circles.		*)
(******************************************************************)
PROCEDURE DrawCircle2(window : GraphicalWindow; x_offset, y_offset,
			    x1, y1, r, colour : INTEGER);
BEGIN
   PutCircle(window, x_offset + x1, y_offset + y1, r, colour, FALSE);
END DrawCircle2;


(******************************************************************)
(* This a near procedure for drawing solid circles.			*)
(******************************************************************)
PROCEDURE DrawDisc(x_offset, y_offset, x1, y1, r, colour : INTEGER);
BEGIN
   TrueDisc(x_offset + x1, y_offset + y1, r, colour);
END DrawDisc;


(******************************************************************)
(* This a near procedure for drawing solid circles.			*)
(******************************************************************)
PROCEDURE DrawDisc2(window : GraphicalWindow; x_offset, y_offset, x1, y1, r, colour : INTEGER);
BEGIN
   PutCircle(window, x_offset + x1, y_offset + y1, r, colour, TRUE);
END DrawDisc2;



(******************************************************************)
(* This procedure draws the "New" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE New(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,0,0,12,0);
   DrawLine(x_offset,y_offset,0,12,10,12,0);
   DrawLine(x_offset,y_offset,10,12,10,3,0);
   DrawLine(x_offset,y_offset,9,3,7,3,0);
   DrawLine(x_offset,y_offset,7,2,7,0,0);
   DrawLine(x_offset,y_offset,7,0,0,0,0);
   DrawDot(x_offset,y_offset,8,1,0);
   DrawDot(x_offset,y_offset,9,2,0);

   DrawRectangle(x_offset,y_offset,1,4,9,11,15,TRUE);
   DrawRectangle(x_offset,y_offset,1,1,6,3,15,TRUE);
   DrawDot(x_offset,y_offset,8,2,15);

END New;


(******************************************************************)
(* This procedure draws the "Open" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Open(x_offset,y_offset : INTEGER);
BEGIN

   (* folder *)
   DrawLine(x_offset,y_offset,0,4,0,12,0);
   DrawLine(x_offset,y_offset,0,12,10,12,0);

   DrawLine(x_offset,y_offset,0,12,5,7,0);
   DrawLine(x_offset,y_offset,10,12,15,7,0);

   DrawLine(x_offset,y_offset,5,7,15,7,0);
   DrawLine(x_offset,y_offset,1,3,3,3,0);
   DrawLine(x_offset,y_offset,4,4,10,4,0);
   DrawLine(x_offset,y_offset,10,4,10,6,0);

   (* arrow *)
   DrawDot(x_offset,y_offset,8,1,0);
   DrawLine(x_offset,y_offset,9,0,11,0,0);
   DrawDot(x_offset,y_offset,12,1,0);
   DrawLine(x_offset,y_offset,12,3,14,3,0);
   DrawLine(x_offset,y_offset,14,1,14,3,0);
   DrawDot(x_offset,y_offset,13,2,0);

   (* outer shade *)
   DrawLine(x_offset,y_offset,2,11,10,11,2+12);
   DrawLine(x_offset,y_offset,3,10,11,10,2+12);
   DrawLine(x_offset,y_offset,4,9,12,9,2+12);
   DrawLine(x_offset,y_offset,5,8,13,8,2+12);
   
   (* inner shade *)
   DrawLine(x_offset,y_offset,1,10,6,5,14);
   DrawLine(x_offset,y_offset,1,8,4,5,14);
   DrawLine(x_offset,y_offset,1,6,3,4,14);
   DrawDot(x_offset,y_offset,1,4,14);
   DrawDot(x_offset,y_offset,9,6,14);
   DrawLine(x_offset,y_offset,7,6,8,5,14);

END Open;


(******************************************************************)
(* This procedure draws the "Save" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Save(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,0,0,12,0);
   DrawLine(x_offset,y_offset,0,0,13,0,0);
   DrawLine(x_offset,y_offset,13,0,13,13,0);
   DrawLine(x_offset,y_offset,13,13,1,13,0);

   DrawLine(x_offset,y_offset,2,1,2,6,0);
   DrawLine(x_offset,y_offset,3,7,10,7,0);
   DrawLine(x_offset,y_offset,11,1,11,6,0);
   DrawDot(x_offset,y_offset,12,2,0);

   DrawRectangle(x_offset,y_offset,3,9,8,12,0,TRUE);
   DrawLine(x_offset,y_offset,9,9,11,9,0);
   DrawLine(x_offset,y_offset,11,9,11,12,0);

   (* shade *)
   DrawLine(x_offset,y_offset,1,1,1,12,14-5);
   DrawLine(x_offset,y_offset,2,7,2,12,14-5);
   DrawLine(x_offset,y_offset,3,8,12,8,14-5);
   DrawLine(x_offset,y_offset,12,3,12,12,14-5);
   DrawLine(x_offset,y_offset,11,7,11,8,14-5);

END Save;


(******************************************************************)
(* This procedure draws the "Cut" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Cut(x_offset,y_offset : INTEGER);
BEGIN

   (* blade *)
   DrawLine(x_offset,y_offset,2,0,2,3,0);
   DrawLine(x_offset,y_offset,3,3,3,5,0);
   DrawLine(x_offset,y_offset,3,5,5,5,0);
   DrawLine(x_offset,y_offset,5,5,5,3,0);
   DrawLine(x_offset,y_offset,6,3,6,0,0);
   DrawLine(x_offset,y_offset,4,6,4,7,0);

   (* left handle *)
   DrawLine(x_offset,y_offset,3,7,3,12,1);
   DrawLine(x_offset,y_offset,2,13,1,13,1);
   DrawLine(x_offset,y_offset,0,12,0,10,1);
   DrawLine(x_offset,y_offset,1,9,2,9,1);

   (* right handle *)   
   DrawLine(x_offset,y_offset,5,7,5,11,1);
   DrawLine(x_offset,y_offset,6,12,7,12,1);
   DrawLine(x_offset,y_offset,8,11,8,9,1);
   DrawLine(x_offset,y_offset,7,8,6,8,1);

END Cut;


(******************************************************************)
(* This procedure draws the "Copy" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Copy(x_offset,y_offset : INTEGER);
BEGIN

   (* back *)
   DrawLine(x_offset,y_offset,0,0,0,9,0);
   DrawLine(x_offset,y_offset,0,9,5,9,0);
   DrawLine(x_offset,y_offset,0,0,5,0,0);
   DrawLine(x_offset,y_offset,5,0,5,3,0);
   DrawLine(x_offset,y_offset,2,3,3,3,0);
   DrawLine(x_offset,y_offset,2,5,5,5,0);
   DrawLine(x_offset,y_offset,2,7,5,7,0);
   DrawDot(x_offset,y_offset,6,1,0);
   DrawDot(x_offset,y_offset,7,2,0);
   DrawRectangle(x_offset,y_offset,1,1,4,2,15,TRUE);
   DrawLine(x_offset,y_offset,2,4,5,4,15);
   DrawLine(x_offset,y_offset,2,6,5,6,15);
   DrawLine(x_offset,y_offset,2,8,5,8,15);
   DrawLine(x_offset,y_offset,1,3,1,8,15);
   DrawDot(x_offset,y_offset,4,3,15);
   DrawDot(x_offset,y_offset,6,2,15);

   (* front *)
   DrawLine(x_offset,y_offset,6,3,6,12,1);
   DrawLine(x_offset,y_offset,6,12,14,12,1);
   DrawLine(x_offset,y_offset,14,12,14,6,1);
   DrawLine(x_offset,y_offset,14,6,11,6,1);
   DrawLine(x_offset,y_offset,11,6,11,3,1);
   DrawLine(x_offset,y_offset,11,3,6,3,1);
   DrawDot(x_offset,y_offset,12,4,1);
   DrawDot(x_offset,y_offset,13,5,1);
   DrawLine(x_offset,y_offset,8,6,9,6,0);
   DrawLine(x_offset,y_offset,8,8,12,8,0);
   DrawLine(x_offset,y_offset,8,10,12,10,0);
   DrawRectangle(x_offset,y_offset,7,4,10,5,15,TRUE);
   DrawLine(x_offset,y_offset,8,7,13,7,15);
   DrawLine(x_offset,y_offset,8,9,13,9,15);
   DrawLine(x_offset,y_offset,8,11,13,11,15);
   DrawLine(x_offset,y_offset,7,6,7,11,15);
   DrawDot(x_offset,y_offset,10,6,15);
   DrawDot(x_offset,y_offset,12,5,15);

END Copy;


(******************************************************************)
(* This procedure draws the "Paste" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Paste(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,2,0,11,0);
   DrawLine(x_offset,y_offset,1,12,5,12,0);
   DrawLine(x_offset,y_offset,1,1,5,1,0);
   DrawLine(x_offset,y_offset,5,0,8,0,0);
   DrawLine(x_offset,y_offset,8,1,12,1,0);
   DrawLine(x_offset,y_offset,13,2,13,6,0);
   DrawLine(x_offset,y_offset,3,3,3,4,0);
   DrawLine(x_offset,y_offset,4,4,9,4,0);
   DrawLine(x_offset,y_offset,10,4,10,3,0);
   DrawDot(x_offset,y_offset,4,2,0);
   DrawDot(x_offset,y_offset,9,2,0);
   DrawLine(x_offset,y_offset,6,2,7,2,0);

   DrawLine(x_offset,y_offset,6,6,6,13,1);
   DrawLine(x_offset,y_offset,6,13,15,13,1);
   DrawLine(x_offset,y_offset,15,13,15,9,1);
   DrawLine(x_offset,y_offset,15,9,12,9,1);
   DrawLine(x_offset,y_offset,12,9,12,6,1);
   DrawLine(x_offset,y_offset,12,6,6,6,1);
   DrawDot(x_offset,y_offset,13,7,1);
   DrawDot(x_offset,y_offset,14,8,1);
   DrawLine(x_offset,y_offset,8,9,10,9,1);
   DrawLine(x_offset,y_offset,8,11,13,11,1);

   DrawRectangle(x_offset,y_offset,7,7,11,8,15,TRUE);
   DrawDot(x_offset,y_offset,11,9,15);
   DrawLine(x_offset,y_offset,7,9,7,12,15);
   DrawLine(x_offset,y_offset,8,10,14,10,15);
   DrawLine(x_offset,y_offset,8,12,14,12,15);
   DrawLine(x_offset,y_offset,14,10,14,12,15);
   DrawDot(x_offset,y_offset,13,8,15);

END Paste;


(******************************************************************)
(* This procedure draws the "Undo" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Undo(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,1,0,5,1);
   DrawLine(x_offset,y_offset,1,2,1,5,1);
   DrawLine(x_offset,y_offset,2,3,2,5,1);
   DrawLine(x_offset,y_offset,3,4,3,5,1);
   DrawDot(x_offset,y_offset,4,5,1);
   DrawLine(x_offset,y_offset,3,2,4,1,1);
   DrawLine(x_offset,y_offset,4,1,5,1,1);
   DrawLine(x_offset,y_offset,6,0,9,0,1);
   DrawLine(x_offset,y_offset,10,1,11,2,1);
   DrawLine(x_offset,y_offset,11,2,11,4,1);
   DrawLine(x_offset,y_offset,10,5,10,6,1);

   DrawLine(x_offset,y_offset,10,0,11,1,8);
   DrawDot(x_offset,y_offset,11,5,8);
   DrawDot(x_offset,y_offset,9,6,8);

END Undo;


(******************************************************************)
(* This procedure draws the "Redo" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Redo(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,2,0,4,1);
   DrawLine(x_offset,y_offset,1,5,1,6,1);
   DrawLine(x_offset,y_offset,0,1,0,5,1);
   DrawLine(x_offset,y_offset,1,1,2,0,1);
   DrawLine(x_offset,y_offset,2,0,5,0,1);
   DrawLine(x_offset,y_offset,6,1,7,1,1);
   DrawLine(x_offset,y_offset,7,1,8,2,1);
   DrawDot(x_offset,y_offset,7,5,1);
   DrawLine(x_offset,y_offset,8,5,8,4,1);
   DrawLine(x_offset,y_offset,9,5,9,3,1);
   DrawLine(x_offset,y_offset,10,5,10,2,1);
   DrawLine(x_offset,y_offset,11,5,11,1,1);

   DrawLine(x_offset,y_offset,0,1,1,0,8);
   DrawDot(x_offset,y_offset,0,5,8);
   DrawDot(x_offset,y_offset,2,6,8);

END Redo;


(******************************************************************)
(* This procedure draws the "Print" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Print(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,7,0,11,0);
   DrawLine(x_offset,y_offset,0,11,2,13,0);
   DrawLine(x_offset,y_offset,2,13,12,13,0);
   DrawLine(x_offset,y_offset,12,13,14,11,0);
   DrawLine(x_offset,y_offset,14,11,14,9,0);
   DrawLine(x_offset,y_offset,15,8,15,5,0);
   DrawLine(x_offset,y_offset,14,4,11,4,0);
   DrawLine(x_offset,y_offset,12,4,12,2,0);
   DrawLine(x_offset,y_offset,13,1,13,0,0);
   DrawLine(x_offset,y_offset,13,0,5,0,0);
   DrawLine(x_offset,y_offset,4,1,4,2,0);
   DrawLine(x_offset,y_offset,3,3,3,4,0);
   DrawLine(x_offset,y_offset,2,5,1,6,0);

   DrawRectangle(x_offset,y_offset,0,8,12,11,0,FALSE);
   DrawLine(x_offset,y_offset,12,11,13,12,0);
   DrawLine(x_offset,y_offset,12,10,14,10,0);
   DrawLine(x_offset,y_offset,13,7,14,6,0);
   DrawLine(x_offset,y_offset,11,7,13,5,0);
   DrawLine(x_offset,y_offset,11,5,10,6,0);
   DrawLine(x_offset,y_offset,10,6,1,6,0);
   DrawLine(x_offset,y_offset,6,2,10,2,0);
   DrawLine(x_offset,y_offset,5,4,9,4,0);

   DrawLine(x_offset,y_offset,7,9,9,9,8);
   DrawLine(x_offset,y_offset,7,10,9,10,14);
   DrawLine(x_offset,y_offset,5,1,12,1,15);
   DrawLine(x_offset,y_offset,5,1,5,2,15);
   DrawLine(x_offset,y_offset,4,3,11,3,15);
   DrawLine(x_offset,y_offset,4,3,4,4,15);
   DrawLine(x_offset,y_offset,3,5,10,5,15);
   DrawLine(x_offset,y_offset,10,5,10,4,15);
   DrawLine(x_offset,y_offset,11,2,12,1,15);

END Print;


(******************************************************************)
(* This procedure draws the "Arrow" tool icon.				*)
(******************************************************************)
PROCEDURE Arrow(x_offset,y_offset : INTEGER);
VAR x1,y1,x2,d : INTEGER;
BEGIN

   (* arrow *)
   DrawLine(x_offset,y_offset,0,0,0,16,0);
   DrawLine(x_offset,y_offset,0,0,11,11,0);
   DrawLine(x_offset,y_offset,0,16,4,12,0);
   DrawLine(x_offset,y_offset,11,11,7,11,0);

   DrawLine(x_offset,y_offset,4,12,4,13,0);
   DrawLine(x_offset,y_offset,5,14,5,15,0);
   DrawLine(x_offset,y_offset,6,16,6,17,0);
   DrawLine(x_offset,y_offset,7,18,7,19,0);
   DrawLine(x_offset,y_offset,8,20,9,20,0);

   DrawLine(x_offset,y_offset,7,11,7,13,0);
   DrawLine(x_offset,y_offset,8,14,8,15,0);
   DrawLine(x_offset,y_offset,9,16,9,17,0);
   DrawLine(x_offset,y_offset,10,18,10,19,0);

   (* 3D effect *)
   DrawLine(x_offset,y_offset,1,4,1,13,15);
   DrawLine(x_offset,y_offset,2,6,2,12,15);
   DrawLine(x_offset,y_offset,3,8,3,11,15);
   DrawLine(x_offset,y_offset,4,10,4,10,15);
   DrawLine(x_offset,y_offset,5,12,5,13,15);
   DrawLine(x_offset,y_offset,6,14,6,15,15);
   DrawLine(x_offset,y_offset,7,16,7,17,15);
   DrawDot(x_offset,y_offset,8,18,15);
END Arrow;


(******************************************************************)
(* This procedure draws the free-hand sketch tool icon.		*)
(******************************************************************)
PROCEDURE Pencil(x_offset,y_offset : INTEGER);
BEGIN

   (* black outline *)
   DrawLine(x_offset,y_offset,18,0,2,16,0);
   DrawLine(x_offset,y_offset,2,16,2,17,0);
   DrawLine(x_offset,y_offset,1,18,1,19,0);
   DrawLine(x_offset,y_offset,0,20,0,22,0);
   DrawLine(x_offset,y_offset,1,21,2,21,0);
   DrawLine(x_offset,y_offset,3,20,4,19,0);
   DrawLine(x_offset,y_offset,5,19,21,3,0);
   DrawLine(x_offset,y_offset,21,2,21,1,0);
   DrawLine(x_offset,y_offset,20,0,19,0,0);
   DrawLine(x_offset,y_offset,19,1,20,2,0);
   DrawLine(x_offset,y_offset,18,4,17,3,0);
   DrawLine(x_offset,y_offset,16,6,15,5,0);
   DrawLine(x_offset,y_offset,15,6,3,18,0);

   (* yellow part *)
   DrawLine(x_offset,y_offset,3,17,14,6,14);
   DrawLine(x_offset,y_offset,3,16,14,5,14);
   DrawLine(x_offset,y_offset,4,18,15,7,14);
   DrawLine(x_offset,y_offset,5,18,16,7,14);

   DrawLine(x_offset,y_offset,1,20,2,20,15);
   DrawLine(x_offset,y_offset,2,19,3,19,15);
   DrawDot(x_offset,y_offset,2,18,15);

   DrawLine(x_offset,y_offset,15,4,16,4,8);
   DrawLine(x_offset,y_offset,16,5,17,6,8);

   DrawLine(x_offset,y_offset,17,2,18,1,12);
   DrawRectangle(x_offset,y_offset,18,2,19,3,12,TRUE);
   DrawLine(x_offset,y_offset,19,4,20,3,12);
   DrawDot(x_offset,y_offset,20,1,12);

END Pencil;


(******************************************************************)
(* This procedure draws the flood-fill tool icon.			*)
(******************************************************************)
PROCEDURE Fill(x_offset,y_offset : INTEGER);
BEGIN

   (* red paint *)
   DrawLine(x_offset,y_offset,0,21,12,21,4);
   DrawLine(x_offset,y_offset,2,20,9,20,4);
   DrawLine(x_offset,y_offset,4,19,7,19,4);
   DrawRectangle(x_offset,y_offset,5,18,6,9,4,TRUE);
   DrawLine(x_offset,y_offset,7,10,7,8,4);
   DrawLine(x_offset,y_offset,8,9,8,7,4);
   DrawRectangle(x_offset,y_offset,9,8,10,7,4,TRUE);
   DrawRectangle(x_offset,y_offset,10,7,11,6,4,TRUE);

   (* bucket outline *)
   DrawLine(x_offset,y_offset,7,11,13,17,0);
   DrawLine(x_offset,y_offset,14,17,15,17,0);
   DrawLine(x_offset,y_offset,16,16,17,16,0);
   DrawLine(x_offset,y_offset,18,15,19,14,0);
   DrawLine(x_offset,y_offset,20,13,20,12,0);
   DrawLine(x_offset,y_offset,21,11,21,9,0);
   DrawLine(x_offset,y_offset,21,9,13,1,0);
   DrawLine(x_offset,y_offset,12,1,11,1,0);
   DrawLine(x_offset,y_offset,10,2,10,3,0);
   DrawLine(x_offset,y_offset,10,3,16,9,0);
   DrawLine(x_offset,y_offset,14,9,16,7,0);
   DrawDot(x_offset,y_offset,13,5,0);
   DrawLine(x_offset,y_offset,12,7,11,8,0);
   DrawLine(x_offset,y_offset,10,9,9,9,0);
   DrawLine(x_offset,y_offset,8,10,7,11,0);
   DrawLine(x_offset,y_offset,5,8,5,6,0);
   DrawLine(x_offset,y_offset,6,6,6,5,0);
   DrawLine(x_offset,y_offset,6,5,9,2,0);
   DrawLine(x_offset,y_offset,4,5,3,4,0);
   DrawLine(x_offset,y_offset,3,4,3,2,0);
   DrawLine(x_offset,y_offset,4,1,5,0,0);
   DrawLine(x_offset,y_offset,5,0,7,0,0);
   DrawDot(x_offset,y_offset,8,1,0);
   DrawLine(x_offset,y_offset,14,2,14,4,0);

   (* bucket exterior colour *)
   DrawRectangle(x_offset,y_offset,10,10,19,13,3,TRUE);
   DrawLine(x_offset,y_offset,11,14,18,14,3);
   DrawLine(x_offset,y_offset,12,15,17,15,3);
   DrawLine(x_offset,y_offset,13,16,15,16,3);
   DrawLine(x_offset,y_offset,9,10,9,12,3);
   DrawDot(x_offset,y_offset,8,11,3);
   DrawLine(x_offset,y_offset,11,9,13,9,3);
   DrawLine(x_offset,y_offset,12,8,14,8,3);
   DrawDot(x_offset,y_offset,13,7,3);
   DrawDot(x_offset,y_offset,12,6,3);
   DrawLine(x_offset,y_offset,14,5,14,6,3);
   DrawLine(x_offset,y_offset,15,4,15,7,3);
   DrawLine(x_offset,y_offset,16,5,16,6,3);
   DrawLine(x_offset,y_offset,17,6,17,9,3);
   DrawLine(x_offset,y_offset,16,8,19,8,3);
   DrawLine(x_offset,y_offset,18,7,18,9,3);
   DrawLine(x_offset,y_offset,19,8,19,9,3);
   DrawLine(x_offset,y_offset,20,9,20,11,3);
   DrawDot(x_offset,y_offset,15,9,3);

   (* bucket interior colour *)
   DrawLine(x_offset,y_offset,6,7,6,8,8);
   DrawLine(x_offset,y_offset,7,5,7,7,8);
   DrawLine(x_offset,y_offset,8,4,8,6,8);
   DrawLine(x_offset,y_offset,9,3,9,6,8);
   DrawLine(x_offset,y_offset,10,4,10,5,8);
   DrawDot(x_offset,y_offset,11,5,8);
   DrawRectangle(x_offset,y_offset,11,2,13,3,8,TRUE);
   DrawLine(x_offset,y_offset,12,4,13,4,8);

END Fill;


(******************************************************************)
(* This procedure draws the circle tool icon.				*)
(******************************************************************)
PROCEDURE Circle(x_offset,y_offset : INTEGER);
BEGIN
   DrawCircle(x_offset,y_offset,10,10,11,0);
END Circle;


(******************************************************************)
(* This procedure draws the rectangle tool icon.			*)
(******************************************************************)
PROCEDURE Square(x_offset,y_offset : INTEGER);
BEGIN

   (*DrawRectangle(x_offset,y_offset,0,0,21,21,0,FALSE);*)

   DrawLine(x_offset,y_offset,0,0,0,20,15);
   DrawLine(x_offset,y_offset,0,0,20,0,15);

   DrawRectangle(x_offset,y_offset,1,1,20,20,0,FALSE);

   DrawLine(x_offset,y_offset,2,2,2,18,8);
   DrawLine(x_offset,y_offset,2,2,18,2,8);
   DrawLine(x_offset,y_offset,2,19,19,19,15);
   DrawLine(x_offset,y_offset,19,19,19,2,15);
   DrawLine(x_offset,y_offset,2,21,21,21,8);
   DrawLine(x_offset,y_offset,21,21,21,2,8);

END Square;


(******************************************************************)
(* This procedure draws the solid rectangle tool icon.		*)
(******************************************************************)
PROCEDURE FilledSquare(x_offset,y_offset : INTEGER);
BEGIN

   DrawRectangle(x_offset,y_offset,0,0,21,21,0+4,TRUE);
   DrawRectangle(x_offset,y_offset,0,0,21,21,0,FALSE);

   (*DrawLine(x_offset,y_offset,0,0,0,20,15);
   DrawLine(x_offset,y_offset,0,0,20,0,15);

   DrawRectangle(x_offset,y_offset,1,1,20,20,0,FALSE);

   DrawLine(x_offset,y_offset,2,2,2,18,8);
   DrawLine(x_offset,y_offset,2,2,18,2,8);
   DrawLine(x_offset,y_offset,2,19,19,19,15);
   DrawLine(x_offset,y_offset,19,19,19,2,15);
   DrawLine(x_offset,y_offset,2,21,21,21,8);
   DrawLine(x_offset,y_offset,21,21,21,2,8);

   DrawRectangle(x_offset,y_offset,3,3,18,18,0+6,TRUE);*)


END FilledSquare;


(******************************************************************)
(* This procedure draws the straight line tool icon.			*)
(******************************************************************)
PROCEDURE StraightLine(x_offset,y_offset : INTEGER);
BEGIN

   (*DrawLine(x_offset,y_offset,0,21,21,0,0);*)

   DrawLine(x_offset,y_offset,1,19,20,0,15);
   DrawLine(x_offset,y_offset,1,20,20,1,0);
   DrawLine(x_offset,y_offset,1,21,20,2,8);

END StraightLine;


(******************************************************************)
(* This procedure draws the "Text" tool icon.				*)
(******************************************************************)
PROCEDURE Text(x_offset,y_offset : INTEGER);
BEGIN

   (* letter A *)
   DrawRectangle(x_offset,y_offset,0,10,1,11,4,TRUE);
   DrawRectangle(x_offset,y_offset,1,8,2,9,4,TRUE);
   DrawRectangle(x_offset,y_offset,2,6,3,7,4,TRUE);
   DrawRectangle(x_offset,y_offset,3,4,4,5,4,TRUE);
   DrawRectangle(x_offset,y_offset,4,2,5,3,4,TRUE);
   DrawRectangle(x_offset,y_offset,5,0,6,1,4,TRUE);
   DrawRectangle(x_offset,y_offset,6,2,7,3,4,TRUE);
   DrawRectangle(x_offset,y_offset,7,4,8,5,4,TRUE);
   DrawRectangle(x_offset,y_offset,8,6,9,7,4,TRUE);
   DrawRectangle(x_offset,y_offset,9,8,10,9,4,TRUE);
   DrawLine(x_offset,y_offset,10,11,11,11,4);
   DrawLine(x_offset,y_offset,4,7,7,7,4);
   DrawLine(x_offset,y_offset,3,8,8,8,4);

   (* letter C *)
   DrawLine(x_offset,y_offset,8,10,12,10,14);
   DrawDot(x_offset,y_offset,7,9,14);
   DrawLine(x_offset,y_offset,7,11,8,11,14);
   DrawDot(x_offset,y_offset,9,12,14);
   DrawLine(x_offset,y_offset,6,12,7,12,14);
   DrawRectangle(x_offset,y_offset,5,13,6,14,14,TRUE);
   DrawRectangle(x_offset,y_offset,4,15,5,19,14,TRUE);
   DrawRectangle(x_offset,y_offset,5,20,6,21,14,TRUE);
   DrawLine(x_offset,y_offset,7,22,11,22,14);
   DrawLine(x_offset,y_offset,12,21,13,20,14);
   DrawLine(x_offset,y_offset,13,11,14,12,14);
   DrawLine(x_offset,y_offset,10,13,13,13,14);

   (* letter B *)
   DrawRectangle(x_offset,y_offset,11,6,15,7,1,TRUE);
   DrawRectangle(x_offset,y_offset,12,8,15,9,1,TRUE);
   DrawDot(x_offset,y_offset,15,5,1);
   DrawLine(x_offset,y_offset,13,10,17,10,1);
   DrawLine(x_offset,y_offset,16,9,20,9,1);
   DrawLine(x_offset,y_offset,17,8,19,8,1);
   DrawRectangle(x_offset,y_offset,18,10,21,13,1,TRUE);
   DrawLine(x_offset,y_offset,14,11,15,11,1);
   DrawLine(x_offset,y_offset,15,12,15,13,1);
   DrawDot(x_offset,y_offset,14,13,1);
   DrawLine(x_offset,y_offset,12,14,15,14,1);
   DrawLine(x_offset,y_offset,12,15,19,15,1);
   DrawLine(x_offset,y_offset,15,16,17,16,1);
   DrawLine(x_offset,y_offset,18,14,20,14,1);
   DrawLine(x_offset,y_offset,12,11,13,12,1);
   DrawDot(x_offset,y_offset,12,12,1);

END Text;


(******************************************************************)
(* This procedure draws the colour dropper tool icon.			*)
(******************************************************************)
PROCEDURE Dropper_Old(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,20,7,20,11);
   DrawDot(x_offset,y_offset,3,18,11);
   DrawLine(x_offset,y_offset,4,16,5,15,11);
   DrawLine(x_offset,y_offset,2,19,2,18,0);
   DrawLine(x_offset,y_offset,3,19,4,18,0);
   DrawLine(x_offset,y_offset,6,17,18,5,0);
   DrawLine(x_offset,y_offset,3,17,3,16,0);
   DrawLine(x_offset,y_offset,4,15,14,5,0);
   DrawDot(x_offset,y_offset,17,4,0);
   DrawLine(x_offset,y_offset,4,17,6,15,2);
   DrawLine(x_offset,y_offset,7,14,15,6,15);
   DrawLine(x_offset,y_offset,5,17,16,6,8);
   DrawLine(x_offset,y_offset,15,4,16,3,6);
   DrawLine(x_offset,y_offset,17,2,17,1,6);
   DrawLine(x_offset,y_offset,18,0,20,0,6);
   DrawLine(x_offset,y_offset,20,1,21,1,6);
   DrawLine(x_offset,y_offset,20,2,21,2,6);
   DrawLine(x_offset,y_offset,18,3,20,3,6);
   DrawLine(x_offset,y_offset,18,4,19,4,6);
   DrawLine(x_offset,y_offset,16,5,17,5,6);
   DrawDot(x_offset,y_offset,18,6,6);
   DrawLine(x_offset,y_offset,15,3,16,4,12);
   DrawLine(x_offset,y_offset,17,3,18,2,12);
   DrawLine(x_offset,y_offset,19,2,19,1,12);
   DrawDot(x_offset,y_offset,18,1,15);
   DrawLine(x_offset,y_offset,19,5,21,3,8);
   DrawDot(x_offset,y_offset,21,0,8);

END Dropper_Old;


(******************************************************************)
(* This procedure draws the colour dropper tool icon.			*)
(******************************************************************)
PROCEDURE Dropper(x_offset,y_offset : INTEGER);
BEGIN
   (* outline *)
   DrawLine(x_offset,y_offset,0,18,0,20,0);
   DrawLine(x_offset,y_offset,1,21,3,21,0);
   DrawLine(x_offset,y_offset,1,17,2,17,0);
   DrawLine(x_offset,y_offset,3,16,3,15,0);
   DrawLine(x_offset,y_offset,4,14,9,9,0);
   DrawLine(x_offset,y_offset,4,20,4,19,0);
   DrawLine(x_offset,y_offset,5,18,6,18,0);
   DrawLine(x_offset,y_offset,7,17,12,12,0);
   DrawLine(x_offset,y_offset,10,8,13,11,0);
   DrawLine(x_offset,y_offset,10,7,14,11,0);
   DrawLine(x_offset,y_offset,15,11,15,8,0);
   DrawLine(x_offset,y_offset,13,7,14,8,0);
   DrawLine(x_offset,y_offset,14,8,18,8,0);
   DrawLine(x_offset,y_offset,15,9,16,9,0);
   DrawLine(x_offset,y_offset,18,8,19,7,0);
   DrawLine(x_offset,y_offset,20,6,20,5,0);
   DrawLine(x_offset,y_offset,21,4,21,2,0);
   DrawLine(x_offset,y_offset,21,2,20,1,0);

   (* head *)
   DrawLine(x_offset,y_offset,14,7,18,7,4);
   DrawLine(x_offset,y_offset,12,6,19,6,4);
   DrawLine(x_offset,y_offset,13,5,19,5,4);
   DrawLine(x_offset,y_offset,13,3,13,5,4);
   DrawLine(x_offset,y_offset,14,2,14,5,4);
   DrawLine(x_offset,y_offset,15,1,19,1,4);
   DrawLine(x_offset,y_offset,17,0,19,0,4);
   DrawLine(x_offset,y_offset,18,4,20,4,4);
   DrawLine(x_offset,y_offset,19,3,20,3,4);
   DrawLine(x_offset,y_offset,20,3,20,2,4);
   DrawLine(x_offset,y_offset,14,9,14,10,4);
   DrawLine(x_offset,y_offset,14,9,13,8,4);
   DrawDot(x_offset,y_offset,10,6,4);
   DrawLine(x_offset,y_offset,15,2,15,4,12);
   DrawLine(x_offset,y_offset,15,4,17,4,12);
   DrawLine(x_offset,y_offset,17,4,17,3,12);
   DrawLine(x_offset,y_offset,17,3,18,3,12);
   DrawLine(x_offset,y_offset,18,3,18,2,12);
   DrawLine(x_offset,y_offset,18,2,19,2,12);
   DrawLine(x_offset,y_offset,11,6,12,7,12);
   DrawLine(x_offset,y_offset,11,7,13,9,12);
   DrawLine(x_offset,y_offset,16,3,17,2,15);
   DrawDot(x_offset,y_offset,16,2,7);
   DrawLine(x_offset,y_offset,12,4,12,5,8);
   DrawLine(x_offset,y_offset,21,5,21,6,8);
   DrawLine(x_offset,y_offset,20,7,19,8,8);
   DrawDot(x_offset,y_offset,17,9,8);

   (* tube *)
   DrawRectangle(x_offset,y_offset,1,18,2,19,3+8,TRUE);
   DrawLine(x_offset,y_offset,4,16,6-1,14+1,3+8);
   DrawLine(x_offset,y_offset,1,20,3,20,2);
   DrawLine(x_offset,y_offset,3,20,3,17,2);
   DrawRectangle(x_offset,y_offset,3,17,4,18,2,TRUE);
   DrawLine(x_offset,y_offset,4,15,5-1,14+1,2);
   DrawLine(x_offset,y_offset,5,16,7-1,14+1,2);
   DrawLine(x_offset,y_offset,6,17,9-1,14+1,2);
   DrawLine(x_offset,y_offset,5,17,8-1,14+1,1);
   DrawLine(x_offset,y_offset,9-1,13+1,11,11,0);
   DrawLine(x_offset,y_offset,7-1,13+1,10,10,15);
   DrawLine(x_offset,y_offset,10-1,13+1,12,11,8);
END Dropper;


(******************************************************************)
(* This procedure draws the "Eraser" tool icon.				*)
(******************************************************************)
PROCEDURE Eraser_Old(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,16,0,14,0);
   DrawDot(x_offset,y_offset,1,17,0);
   DrawLine(x_offset,y_offset,2,18,4,18,0);
   DrawLine(x_offset,y_offset,0,14,14,0,0);
   DrawLine(x_offset,y_offset,4,18,21,1,0);
   DrawLine(x_offset,y_offset,4,12,6,14,0);
   DrawLine(x_offset,y_offset,5,10,8,13,0);
   DrawLine(x_offset,y_offset,8,12,20,0,0);
   DrawLine(x_offset,y_offset,7,10,17,0,0);

   DrawLine(x_offset,y_offset,9,12,21,0,6);
   DrawLine(x_offset,y_offset,8,11,19,0,12);
   DrawLine(x_offset,y_offset,7,11,18,0,12);
   DrawLine(x_offset,y_offset,6,10,16,0,12);
   DrawLine(x_offset,y_offset,6,9,15,0,12);

   DrawLine(x_offset,y_offset,1,14,3,12,15);
   DrawLine(x_offset,y_offset,1,15,3,13,15);
   DrawLine(x_offset,y_offset,2,15,5,12,15);
   DrawLine(x_offset,y_offset,2,16,4,14,15);
   DrawLine(x_offset,y_offset,3,16,5,14,15);

   DrawLine(x_offset,y_offset,4,17,6,15,8);
   DrawLine(x_offset,y_offset,4,11,5,11,14);
   DrawLine(x_offset,y_offset,6,12,6,13,14);
   DrawLine(x_offset,y_offset,7,13,7,14,3);

END Eraser_Old;


(******************************************************************)
(* This procedure draws the "Eraser" tool icon.				*)
(******************************************************************)
PROCEDURE Eraser(x_offset,y_offset : INTEGER);
BEGIN
   DrawLine(x_offset,y_offset,0,15,0,13,0);
   DrawLine(x_offset,y_offset,0,13,13,0,0);
   DrawLine(x_offset,y_offset,0,15,3,18,0);
   DrawLine(x_offset,y_offset,3,18,5,18,0);
   DrawLine(x_offset,y_offset,5,18,21,2,0);
   DrawLine(x_offset,y_offset,5,10,8,13,0);
   DrawLine(x_offset,y_offset,7,7,11,11,0);
   DrawLine(x_offset,y_offset,9,7,16,0,0);
   DrawLine(x_offset,y_offset,11,9,20,0,0);
   DrawLine(x_offset,y_offset,9,12,10,13,0);

   DrawLine(x_offset,y_offset,1,15,3,17,8);
   DrawLine(x_offset,y_offset,5,17,8,14,8);
   DrawLine(x_offset,y_offset,2,13,2,14,15);
   DrawLine(x_offset,y_offset,3,12,3,15,15);
   DrawLine(x_offset,y_offset,4,11,4,15,15);
   DrawLine(x_offset,y_offset,5,11,5,14,15);
   DrawLine(x_offset,y_offset,6,12,6,13,15);

   DrawLine(x_offset,y_offset,5,9,8,12,14);
   DrawLine(x_offset,y_offset,6,8,9,11,14);
   DrawLine(x_offset,y_offset,7,8,9,10,14);
   DrawLine(x_offset,y_offset,9,13,10,12,2);
   DrawLine(x_offset,y_offset,10,12,10,11,2);
   DrawDot(x_offset,y_offset,6,9,2);
   DrawDot(x_offset,y_offset,8,11,2);
   DrawDot(x_offset,y_offset,7,10,15);

   DrawLine(x_offset,y_offset,8,6,14,0,12);
   DrawLine(x_offset,y_offset,8,7,15,0,12);
   DrawLine(x_offset,y_offset,9,8,17,0,12);
   DrawLine(x_offset,y_offset,10,8,18,0,12);
   DrawLine(x_offset,y_offset,10,9,19,0,12);
   DrawLine(x_offset,y_offset,11,10,21,0,4);
   DrawLine(x_offset,y_offset,12,10,21,1,4);
END Eraser;


(******************************************************************)
(* This procedure draws the air-brush tool icon.			*)
(******************************************************************)
PROCEDURE AirBrush(x_offset,y_offset : INTEGER);
BEGIN

   DrawDot(x_offset,y_offset,0,1,9);
   DrawLine(x_offset,y_offset,2,0,3,1,9);
   DrawLine(x_offset,y_offset,3,1,1,3,9);
   DrawDot(x_offset,y_offset,1,5,9);
   DrawDot(x_offset,y_offset,3,6,9);
   DrawLine(x_offset,y_offset,5,4,6,3,9);
   DrawLine(x_offset,y_offset,6,3,7,3,9);
   DrawLine(x_offset,y_offset,3,4,5,2,9);

   DrawLine(x_offset,y_offset,10,3,10,4,0);
   DrawLine(x_offset,y_offset,12,3,12,4,0);
   DrawDot(x_offset,y_offset,11,5,0);
   DrawLine(x_offset,y_offset,9,6,10,6,0);
   DrawLine(x_offset,y_offset,12,6,13,6,0);
   DrawDot(x_offset,y_offset,8,7,0);
   DrawDot(x_offset,y_offset,14,7,0);
   DrawLine(x_offset,y_offset,6,8,16,8,0);
   DrawDot(x_offset,y_offset,5,9,0);
   DrawDot(x_offset,y_offset,17,9,0);
   DrawLine(x_offset,y_offset,6,10,16,10,0);
   DrawLine(x_offset,y_offset,6,10,6,21,0);
   DrawLine(x_offset,y_offset,16,10,16,21,0);

   DrawLine(x_offset,y_offset,15,11,15,21,2);
   DrawRectangle(x_offset,y_offset,12,11,13,21,2,TRUE);
   DrawLine(x_offset,y_offset,14,11,14,21,1);
   DrawLine(x_offset,y_offset,11,11,11,21,11);
   DrawLine(x_offset,y_offset,10,11,10,21,15);
   DrawLine(x_offset,y_offset,9,11,9,21,11);
   DrawLine(x_offset,y_offset,8,11,8,21,15);
   DrawLine(x_offset,y_offset,7,11,7,21,2);

   DrawLine(x_offset,y_offset,6,9,7,9,8);
   DrawLine(x_offset,y_offset,13,9,16,9,8);
   DrawLine(x_offset,y_offset,9,9,10,9,15);
   DrawLine(x_offset,y_offset,9,7,10,7,15);
   DrawLine(x_offset,y_offset,12,7,13,7,8);
   DrawDot(x_offset,y_offset,11,6,8);
   DrawDot(x_offset,y_offset,11,4,8);
   DrawDot(x_offset,y_offset,11,3,15);
   DrawLine(x_offset,y_offset,10,2,12,2,8);
   DrawDot(x_offset,y_offset,9,3,1);

END AirBrush;


(******************************************************************)
(* This procedure draws the solid circle tool icon.			*)
(******************************************************************)
PROCEDURE FilledCircle(x_offset,y_offset : INTEGER);
BEGIN

   DrawDisc(x_offset,y_offset,10,10,11,0+1);
   DrawCircle(x_offset,y_offset,10,10,11,0);

END FilledCircle;


(******************************************************************)
(* This procedure draws the "Zoom" tool icon.				*)
(******************************************************************)
PROCEDURE Zoom(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,5,0,9,0);
   DrawLine(x_offset,y_offset,1,4,1,3,0);
   DrawDot(x_offset,y_offset,2,2,0);
   DrawLine(x_offset,y_offset,3,1,4,1,0);
   DrawLine(x_offset,y_offset,5,0,9,0,0);
   DrawLine(x_offset,y_offset,10,1,11,1,0);
   DrawDot(x_offset,y_offset,12,2,0);
   DrawLine(x_offset,y_offset,13,3,13,4,0);
   DrawLine(x_offset,y_offset,14,5,14,9,0);
   DrawLine(x_offset,y_offset,13,10,13,11,0);
   DrawLine(x_offset,y_offset,13,12,19,18,0);
   DrawLine(x_offset,y_offset,12,12,18,18,0);
   DrawLine(x_offset,y_offset,12,13,18,19,0);
   DrawLine(x_offset,y_offset,11,13,10,13,0);
   DrawLine(x_offset,y_offset,9,14,5,14,0);
   DrawLine(x_offset,y_offset,4,13,3,13,0);
   DrawDot(x_offset,y_offset,2,12,0);
   DrawLine(x_offset,y_offset,1,11,1,10,0);

   DrawDot(x_offset,y_offset,19,19,8);
   DrawLine(x_offset,y_offset,2,4,4,2,15);
   DrawLine(x_offset,y_offset,2,5,5,2,15);


   (* glass colour *)
   DrawRectangle(x_offset,y_offset,1,6,13,9,11,TRUE);
   DrawRectangle(x_offset,y_offset,6,1,9,5,11,TRUE);
   DrawLine(x_offset,y_offset,2,10,9,10,11);
   DrawLine(x_offset,y_offset,6,11,8,11,11);
   DrawLine(x_offset,y_offset,3,11,4,11,11);
   DrawLine(x_offset,y_offset,4,12,5,12,11);
   DrawLine(x_offset,y_offset,5,13,9,13,11);
   DrawLine(x_offset,y_offset,10,12,12,10,11);
   DrawLine(x_offset,y_offset,12,10,11,10,11);
   DrawLine(x_offset,y_offset,10,2,10,5,11);
   DrawLine(x_offset,y_offset,11,3,11,5,11);
   DrawLine(x_offset,y_offset,12,4,12,5,11);
   DrawLine(x_offset,y_offset,12,5,13,5,11);
   DrawLine(x_offset,y_offset,5,3,5,5,11);
   DrawLine(x_offset,y_offset,4,4,4,5,11);
   DrawLine(x_offset,y_offset,4,5,3,5,11);
   DrawDot(x_offset,y_offset,1,5,11);
   DrawDot(x_offset,y_offset,5,1,11);
   DrawLine(x_offset,y_offset,2,6,6,2,15);

END Zoom;


(******************************************************************)
(* This procedure draws the cross-hair icon.				*)
(******************************************************************)
PROCEDURE CrossHair(x_offset,y_offset : INTEGER);
BEGIN

   DrawLine(x_offset,y_offset,0,9,7,9,0);
   DrawLine(x_offset,y_offset,9,0,9,7,0);
   DrawLine(x_offset,y_offset,11,9,18,9,0);
   DrawLine(x_offset,y_offset,9,11,9,18,0);

END CrossHair;


(************************************************************************)
(* This procedure draws the colour palette tool icon				*)
(************************************************************************)
PROCEDURE Palette(window : GraphicalWindow; x_offset,y_offset : INTEGER);
BEGIN
   DrawLine2(window,x_offset,y_offset,0,6,0,12,0);
   DrawLine2(window,x_offset,y_offset,1,13,1,15,0);
   DrawLine2(window,x_offset,y_offset,2,16,5,19,0);
   DrawLine2(window,x_offset,y_offset,6,20,7,20,0);
   DrawLine2(window,x_offset,y_offset,8,21,15,21,0);
   DrawDot2(window,x_offset,y_offset,16,20,0);
   DrawLine2(window,x_offset,y_offset,17,19,18,19,0);
   DrawLine2(window,x_offset,y_offset,19,18,19,17,0);
   DrawLine2(window,x_offset,y_offset,20,16,20,11,0);
   DrawLine2(window,x_offset,y_offset,19,10,18,9,0);
   DrawLine2(window,x_offset,y_offset,17,10,17,12,0);
   DrawLine2(window,x_offset,y_offset,16,13,13,13,0);
   DrawDot2(window,x_offset,y_offset,12,12,0);
   DrawLine2(window,x_offset,y_offset,11,11,11,9,0);
   DrawLine2(window,x_offset,y_offset,12,8,14,8,0);
   DrawLine2(window,x_offset,y_offset,15,6,14,5,0);
   DrawLine2(window,x_offset,y_offset,13,4,13,3,0);
   DrawDot2(window,x_offset,y_offset,12,2,0);
   DrawLine2(window,x_offset,y_offset,11,1,10,1,0);
   DrawLine2(window,x_offset,y_offset,9,0,6,0,0);
   DrawLine2(window,x_offset,y_offset,5,1,4,1,0);
   DrawLine2(window,x_offset,y_offset,3,2,2,3,0);
   DrawLine2(window,x_offset,y_offset,1,4,1,5,0);


   (* paint brush *)
   DrawLine2(window,x_offset,y_offset,18,7,18,5,0);
   DrawLine2(window,x_offset,y_offset,19,5,19,1,0);
   DrawLine2(window,x_offset,y_offset,20,2,20,3,0);
   DrawLine2(window,x_offset,y_offset,21,3,21,6,0);
   DrawLine2(window,x_offset,y_offset,20,6,20,7,0);
   DrawLine2(window,x_offset,y_offset,20,7,18,7,0);

   DrawRectangle2(window,x_offset,y_offset,10,16,14,18,5,TRUE);
   DrawLine2(window,x_offset,y_offset,15,16,15,17,5);
   DrawLine2(window,x_offset,y_offset,12,15,13,15,5);
   DrawDot2(window,x_offset,y_offset,9,17,5);

   DrawRectangle2(window,x_offset,y_offset,5,13,7,15,1,TRUE);
   DrawLine2(window,x_offset,y_offset,5,12,6,12,1);
   DrawLine2(window,x_offset,y_offset,4,13,4,14,1);
   DrawLine2(window,x_offset,y_offset,6,16,7,16,1);
   DrawLine2(window,x_offset,y_offset,8,14,8,15,1);
   DrawDot2(window,x_offset,y_offset,9,14,1);

   DrawRectangle2(window,x_offset,y_offset,3,8,6,10,2,TRUE);
   DrawLine2(window,x_offset,y_offset,4,7,6,7,2);
   DrawLine2(window,x_offset,y_offset,7,8,7,9,2);
   DrawDot2(window,x_offset,y_offset,2,9,2);

   DrawRectangle2(window,x_offset,y_offset,6,3,9,5,12,TRUE);
   DrawLine2(window,x_offset,y_offset,8,6,10,6,12);
   DrawLine2(window,x_offset,y_offset,10,6,10,4,12);
   DrawDot2(window,x_offset,y_offset,11,5,12);
   DrawDot2(window,x_offset,y_offset,5,4,12);


   DrawLine2(window,x_offset,y_offset,12,11,16,7,6);
   DrawLine2(window,x_offset,y_offset,13,11,17,7,6);
   DrawLine2(window,x_offset,y_offset,13,12,17,8,6);
   DrawLine2(window,x_offset,y_offset,14,12,18,8,6);
   DrawLine2(window,x_offset,y_offset,3,21,4,21,6);
   DrawLine2(window,x_offset,y_offset,4,20,5,20,6);

   DrawLine2(window,x_offset,y_offset,20,4,20,5,14);
   DrawDot2(window,x_offset,y_offset,19,6,14);

   DrawLine2(window,x_offset,y_offset,12,9,12,10,15);
   DrawLine2(window,x_offset,y_offset,12,9,13,9,15);
   DrawLine2(window,x_offset,y_offset,16,12,15,12,15);
   DrawLine2(window,x_offset,y_offset,16,12,16,11,15);

   (* yellow dots *)
   DrawLine2(window,x_offset,y_offset,2,4,4,2,14);
   DrawLine2(window,x_offset,y_offset,1,7,7,1,14);
   DrawLine2(window,x_offset,y_offset,1,9,5,5,14);
   DrawLine2(window,x_offset,y_offset,8,2,9,1,14);
   DrawLine2(window,x_offset,y_offset,1,9,4,12,14);
   DrawLine2(window,x_offset,y_offset,1,11,3,13,14);
   DrawLine2(window,x_offset,y_offset,2,14,5,11,14);
   DrawLine2(window,x_offset,y_offset,5,5,10,10,14);
   DrawLine2(window,x_offset,y_offset,9,7,10,8,14);
   DrawLine2(window,x_offset,y_offset,12,6,13,7,14);
   DrawLine2(window,x_offset,y_offset,9,1,15,7,14);
   DrawLine2(window,x_offset,y_offset,2,14,5,11,14);
   DrawLine2(window,x_offset,y_offset,7,11,13,5,14);
   DrawLine2(window,x_offset,y_offset,2,14,8,20,14);
   DrawLine2(window,x_offset,y_offset,7,17,10,20,14);
   DrawLine2(window,x_offset,y_offset,7,11,11,15,14);
   DrawLine2(window,x_offset,y_offset,8,10,12,14,14);
   DrawLine2(window,x_offset,y_offset,6,18,11,13,14);
   DrawLine2(window,x_offset,y_offset,11,19,12,20,14);
   DrawLine2(window,x_offset,y_offset,13,19,14,20,14);
   DrawLine2(window,x_offset,y_offset,14,20,19,15,14);
   DrawLine2(window,x_offset,y_offset,14,14,18,18,14);
   DrawLine2(window,x_offset,y_offset,16,16,19,13,14);
   DrawLine2(window,x_offset,y_offset,15,15,19,11,14);
   DrawLine2(window,x_offset,y_offset,19,11,18,10,14);

   (* white dots *)
   DrawLine2(window,x_offset,y_offset,1,6,6,1,15);
   DrawLine2(window,x_offset,y_offset,1,8,4,5,15);
   DrawLine2(window,x_offset,y_offset,7,2,8,1,15);
   DrawLine2(window,x_offset,y_offset,4,5,5,6,15);
   DrawLine2(window,x_offset,y_offset,1,10,3,12,15);
   DrawLine2(window,x_offset,y_offset,1,12,9,20,15);
   DrawLine2(window,x_offset,y_offset,2,15,6,19,15);
   DrawLine2(window,x_offset,y_offset,2,13,4,11,15);
   DrawLine2(window,x_offset,y_offset,9,2,14,7,15);
   DrawLine2(window,x_offset,y_offset,11,2,12,3,15);
   DrawLine2(window,x_offset,y_offset,7,6,10,9,15);
   DrawLine2(window,x_offset,y_offset,6,11,12,5,15);
   DrawLine2(window,x_offset,y_offset,7,12,13,6,15);
   DrawLine2(window,x_offset,y_offset,6,11,8,13,15);
   DrawLine2(window,x_offset,y_offset,7,10,11,14,15);
   DrawLine2(window,x_offset,y_offset,8,9,14,15,15);
   DrawLine2(window,x_offset,y_offset,11,14,6,19,15);
   DrawLine2(window,x_offset,y_offset,8,17,11,20,15);
   DrawLine2(window,x_offset,y_offset,11,20,12,19,15);
   DrawLine2(window,x_offset,y_offset,13,20,19,14,15);
   DrawLine2(window,x_offset,y_offset,15,20,19,16,15);
   DrawLine2(window,x_offset,y_offset,16,15,19,12,15);
   DrawLine2(window,x_offset,y_offset,16,15,15,14,15);
   DrawLine2(window,x_offset,y_offset,19,12,18,11,15);
END Palette;


(******************************************************************)
(* This procedure draws the "Alert" icon.					*)
(******************************************************************)
PROCEDURE Alert(window : GraphicalWindow; x_offset,y_offset : INTEGER);
BEGIN
END Alert;


(******************************************************************)
(* This procedure draws the "Normal View" menu short-cut icon.	*)
(******************************************************************)
PROCEDURE NoZoom(x_offset,y_offset : INTEGER);
BEGIN
   DrawLine(x_offset,y_offset,0,5,0,9,0);
   DrawLine(x_offset,y_offset,1,10,1,11,0);
   DrawDot(x_offset,y_offset,2,12,0);
   DrawLine(x_offset,y_offset,3,13,4,13,0);
   DrawLine(x_offset,y_offset,5,14,10,14,0);
   DrawLine(x_offset,y_offset,11,13,12,13,0);
   DrawDot(x_offset,y_offset,13,12,0);
   DrawLine(x_offset,y_offset,14,11,14,10,0);
   DrawLine(x_offset,y_offset,15,9,15,5,0);
   DrawLine(x_offset,y_offset,14,4,14,3,0);
   DrawDot(x_offset,y_offset,13,2,0);
   DrawLine(x_offset,y_offset,12,1,11,1,0);
   DrawLine(x_offset,y_offset,10,0,5,0,0);
   DrawLine(x_offset,y_offset,4,1,3,1,0);
   DrawDot(x_offset,y_offset,2,2,0);
   DrawLine(x_offset,y_offset,1,3,1,4,0);

   DrawRectangle(x_offset,y_offset,2,3,13,11,12,TRUE);
   DrawRectangle(x_offset,y_offset,3,2,12,12,12,TRUE);
   DrawLine(x_offset,y_offset,1,5,1,9,12);
   DrawLine(x_offset,y_offset,5,1,10,1,12);
   DrawLine(x_offset,y_offset,14,5,14,9,12);
   DrawLine(x_offset,y_offset,5,13,10,13,12);

   (* lense *)
   DrawRectangle(x_offset,y_offset,5,3,7,7,11,TRUE);
   DrawRectangle(x_offset,y_offset,4,4,8,6,11,TRUE);

   DrawLine(x_offset,y_offset,3,12,12,3,0);

   DrawLine(x_offset,y_offset,3,4,3,6,0);
   DrawDot(x_offset,y_offset,4,7,0);
   DrawLine(x_offset,y_offset,5,8,7,8,0);
   DrawDot(x_offset,y_offset,8,7,0);
   DrawLine(x_offset,y_offset,9,6,9,4,0);
   DrawDot(x_offset,y_offset,8,3,0);
   DrawLine(x_offset,y_offset,7,2,5,2,0);
   DrawDot(x_offset,y_offset,4,3,0);

   (* handle *)
   DrawLine(x_offset,y_offset,10,8,12,10,0);
   DrawLine(x_offset,y_offset,9,8,11,10,9);
   DrawLine(x_offset,y_offset,9,9,11,11,0);
END NoZoom;


(******************************************************************)
(* This procedure draws the "Help" menu short-cut icon.		*)
(******************************************************************)
PROCEDURE Help(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,2,1,3,1,TRUE);
   DrawLine(x_offset,y_offset,1,1,2,1,1);
   DrawLine(x_offset,y_offset,2,1,2,0,1);
   DrawLine(x_offset,y_offset,2,0,6,0,1);
   DrawRectangle(x_offset,y_offset,6,1,7,4,1,TRUE);
   DrawLine(x_offset,y_offset,8,2,3,7,1);
   DrawLine(x_offset,y_offset,8,3,3,8,1);
   DrawLine(x_offset,y_offset,3,8,4,8,1);
   DrawLine(x_offset,y_offset,1,4,2,4,1);

   DrawRectangle(x_offset,y_offset,3,10,4,13,1,TRUE);
   DrawRectangle(x_offset,y_offset,2,11,5,12,1,TRUE);

   DrawDot(x_offset,y_offset,0,4,8);
   DrawLine(x_offset,y_offset,2,2,2,3,8);
   DrawDot(x_offset,y_offset,5,1,8);
   DrawDot(x_offset,y_offset,5,4,8);
   DrawLine(x_offset,y_offset,7,0,8,1,8);
   DrawLine(x_offset,y_offset,8,4,7,5,8);
   DrawLine(x_offset,y_offset,5,7,5,8,8);

   (*DrawDot(x_offset,y_offset,2,10,8);
   DrawDot(x_offset,y_offset,5,10,8);
   DrawDot(x_offset,y_offset,2,13,8);
   DrawDot(x_offset,y_offset,5,13,8);*)
END Help;


(************************************************************************)
(* This procedure draws the "Image Information" menu short-cut icon	*)
(************************************************************************)
PROCEDURE Info(x_offset,y_offset : INTEGER);
BEGIN
   DrawLine(x_offset,y_offset,0,5,0,9,9);
   DrawLine(x_offset,y_offset,1,10,1,11,9);
   DrawDot(x_offset,y_offset,2,12,9);
   DrawLine(x_offset,y_offset,3,13,4,13,9);
   DrawLine(x_offset,y_offset,5,14,10,14,9);
   DrawLine(x_offset,y_offset,11,13,12,13,9);
   DrawDot(x_offset,y_offset,13,12,9);
   DrawLine(x_offset,y_offset,14,11,14,10,9);
   DrawLine(x_offset,y_offset,15,9,15,5,9);
   DrawLine(x_offset,y_offset,14,4,14,3,9);
   DrawDot(x_offset,y_offset,13,2,9);
   DrawLine(x_offset,y_offset,12,1,11,1,9);
   DrawLine(x_offset,y_offset,10,0,5,0,9);
   DrawLine(x_offset,y_offset,4,1,3,1,9);
   DrawDot(x_offset,y_offset,2,2,9);
   DrawLine(x_offset,y_offset,1,3,1,4,9);

   DrawRectangle(x_offset,y_offset,2,3,13,11,9,TRUE);
   DrawRectangle(x_offset,y_offset,3,2,12,12,9,TRUE);
   DrawLine(x_offset,y_offset,1,5,1,9,9);
   DrawLine(x_offset,y_offset,5,1,10,1,9);
   DrawLine(x_offset,y_offset,14,5,14,9,9);
   DrawLine(x_offset,y_offset,5,13,10,13,9);

   DrawRectangle(x_offset,y_offset,7,3,8,4,14,TRUE);
   DrawRectangle(x_offset,y_offset,7,6,8,10,14,TRUE);
   DrawDot(x_offset,y_offset,6,6,14);
   DrawLine(x_offset,y_offset,6,11,9,11,14);
END Info;


(******************************************************************)
(* This procedure draws the "Marquee" tool icon.			*)
(******************************************************************)
PROCEDURE Marquee(x_offset,y_offset : INTEGER);
VAR
   i : INTEGER;
BEGIN
   FOR i := 0 TO 18 BY 3 DO
	 DrawLine(x_offset,y_offset,i,0,i+1,0,0);
	 DrawLine(x_offset,y_offset,i,17,i+1,17,0);
   END;

   FOR i := 2 TO 14 BY 3 DO
	 DrawLine(x_offset,y_offset,0,i,0,i+1,0);
	 DrawLine(x_offset,y_offset,19,i,19,i+1,0);
   END;

   FOR i := 1 TO 19 BY 3 DO
	 DrawLine(x_offset,y_offset,i,1,i+1,1,8);
	 DrawLine(x_offset,y_offset,i,18,i+1,18,8);
   END;

   FOR i := 3 TO 15 BY 3 DO
	 DrawLine(x_offset,y_offset,1,i,1,i+1,8);
	 DrawLine(x_offset,y_offset,20,i,20,i+1,8);
   END;
END Marquee;


(******************************************************************)
(* This procedure draws the "Brush" tool icon.				*)
(******************************************************************)
PROCEDURE Brush(x_offset,y_offset : INTEGER);
BEGIN
   DrawLine(x_offset,y_offset,0,20,6,20,0);
   DrawLine(x_offset,y_offset,2,19,9,19,0);
   DrawLine(x_offset,y_offset,3,18,4,17,0);
   DrawLine(x_offset,y_offset,4,17,4,16,0);
   DrawLine(x_offset,y_offset,5,15,5,14,0);
   DrawLine(x_offset,y_offset,5,14,6,13,0);
   DrawLine(x_offset,y_offset,7,12,8,12,0);
   DrawLine(x_offset,y_offset,9,11,12,11,0);
   DrawLine(x_offset,y_offset,12,10,22,0,0);
   DrawLine(x_offset,y_offset,5,18,11,18,0);
   DrawLine(x_offset,y_offset,7,16,8,17,0);
   DrawLine(x_offset,y_offset,8,17,12,17,0);
   DrawLine(x_offset,y_offset,10,16,13,16,0);
   DrawLine(x_offset,y_offset,9,15,14,15,0);
   DrawLine(x_offset,y_offset,11,14,14,14,0);
   DrawLine(x_offset,y_offset,12,13,15,13,0);
   DrawLine(x_offset,y_offset,12,13,12,12,0);
   DrawLine(x_offset,y_offset,15,13,15,12,0);
   DrawLine(x_offset,y_offset,16,12,16,11,0);
   DrawLine(x_offset,y_offset,16,11,18,11,0);
   DrawLine(x_offset,y_offset,17,10,20,10,0);
   DrawLine(x_offset,y_offset,18,9,21,9,0);
   DrawLine(x_offset,y_offset,18,9,18,7,0);
   DrawLine(x_offset,y_offset,17,6,20,9,0);
   DrawLine(x_offset,y_offset,21,9,21,8,0);
   DrawLine(x_offset,y_offset,22,8,22,7,0);

   DrawLine(x_offset,y_offset,6,17,7,17,2);
   DrawLine(x_offset,y_offset,8,16,9,16,2);
   DrawLine(x_offset,y_offset,8,15,11,12,2);
   DrawLine(x_offset,y_offset,10,14,11,13,2);
   DrawLine(x_offset,y_offset,6,15,7,14,2);
   DrawLine(x_offset,y_offset,4,18,10,12,14);
   DrawLine(x_offset,y_offset,5,17,5,16,14);
   DrawLine(x_offset,y_offset,6,14,7,13,14);
   DrawLine(x_offset,y_offset,8,13,9,12,14);

   DrawLine(x_offset,y_offset,13,10,16,7,15);
   DrawLine(x_offset,y_offset,13,11,17,7,15);
   DrawLine(x_offset,y_offset,17,7,17,8,15);
   DrawLine(x_offset,y_offset,13,12,14,12,8);
   DrawLine(x_offset,y_offset,14,12,17,9,8);
   DrawLine(x_offset,y_offset,18,5,22,1,4);
   DrawLine(x_offset,y_offset,19,7,22,4,4);
   DrawLine(x_offset,y_offset,20,7,22,5,4);
   DrawLine(x_offset,y_offset,20,8,22,6,4);
   DrawLine(x_offset,y_offset,18,6,22,2,12);
   DrawLine(x_offset,y_offset,19,6,22,3,12);
   DrawLine(x_offset,y_offset,4,11,7,8,7);
END Brush;


(******************************************************************)
(* This procedure draws the "Polygon" tool icon.			*)
(******************************************************************)
PROCEDURE Polygon(x_offset,y_offset : INTEGER);
BEGIN
   DrawLine(x_offset,y_offset,0,6,0,15,0);
   DrawLine(x_offset,y_offset,0,15,15,15,0);
   DrawLine(x_offset,y_offset,15,15,18,12,0);
   DrawLine(x_offset,y_offset,18,12,18,9,0);
   DrawLine(x_offset,y_offset,18,9,16,7,0);
   DrawLine(x_offset,y_offset,16,7,13,7,0);
   DrawLine(x_offset,y_offset,12,6,12,3,0);
   DrawLine(x_offset,y_offset,12,3,15,0,0);
   DrawLine(x_offset,y_offset,15,0,6,0,0);
   DrawLine(x_offset,y_offset,6,0,0,6,0);
END Polygon;


(******************************************************************)
(* This procedure draws the "Error" tool icon.				*)
(******************************************************************)
PROCEDURE Error(window : GraphicalWindow; x_offset,y_offset : INTEGER);
BEGIN
   DrawDisc2(window,x_offset,y_offset,12,12,13,12);
   DrawCircle2(window,x_offset,y_offset,12,12,13,0);
   DrawRectangle2(window,x_offset,y_offset,0,10,24,14,15,TRUE);
END Error;


(******************************************************************)
(* This procedure draws the "Black" colour icon.			*)
(******************************************************************)
PROCEDURE Black(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,0+16,TRUE);
END Black;


(******************************************************************)
(* This procedure draws the "White" colour icon.			*)
(******************************************************************)
PROCEDURE White(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,15+16,TRUE);
END White;


(******************************************************************)
(* This procedure draws the "Blue" colour icon.				*)
(******************************************************************)
PROCEDURE Blue(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,1+16,TRUE);
END Blue;


(******************************************************************)
(* This procedure draws the "Green" colour icon.			*)
(******************************************************************)
PROCEDURE LightGreen(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,2+16,TRUE);
END LightGreen;


(******************************************************************)
(* This procedure draws the "LightGreen" colour icon.			*)
(******************************************************************)
PROCEDURE FaintGreen(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,3+16,TRUE);
END FaintGreen;


(******************************************************************)
(* This procedure draws the "Red" colour icon.				*)
(******************************************************************)
PROCEDURE Red(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,4+16,TRUE);
END Red;


(******************************************************************)
(* This procedure draws the "Violet" colour icon.			*)
(******************************************************************)
PROCEDURE Violet(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,5+16,TRUE);
END Violet;


(******************************************************************)
(* This procedure draws the "LightRed" colour icon.			*)
(******************************************************************)
PROCEDURE FaintRed(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,6+16,TRUE);
END FaintRed;


(******************************************************************)
(* This procedure draws the "LightGrey" colour icon.			*)
(******************************************************************)
PROCEDURE LightGrey(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,7+16,TRUE);
END LightGrey;


(******************************************************************)
(* This procedure draws the "DarkGrey" colour icon.			*)
(******************************************************************)
PROCEDURE DarkGrey(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,8+16,TRUE);
END DarkGrey;


(******************************************************************)
(* This procedure draws the "Blue" colour icon.				*)
(******************************************************************)
PROCEDURE NavyBlue(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,9+16,TRUE);
END NavyBlue;


(******************************************************************)
(* This procedure draws the "LightGreen" colour icon.			*)
(******************************************************************)
PROCEDURE FluroGreen(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,10+16,TRUE);
END FluroGreen;


(******************************************************************)
(* This procedure draws the "LightCyan" colour icon.			*)
(******************************************************************)
PROCEDURE FluroBlue(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,11+16,TRUE);
END FluroBlue;


(******************************************************************)
(* This procedure draws the "Orange" colour icon.			*)
(******************************************************************)
PROCEDURE Orange(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,12+16,TRUE);
END Orange;


(******************************************************************)
(* This procedure draws the "LightMagenta" colour icon.		*)
(******************************************************************)
PROCEDURE LightViolet(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,13+16,TRUE);
END LightViolet;


(******************************************************************)
(* This procedure draws the "Yellow" colour icon.			*)
(******************************************************************)
PROCEDURE Yellow(x_offset,y_offset : INTEGER);
BEGIN
   DrawRectangle(x_offset,y_offset,0,0,23,12,0,FALSE);
   DrawRectangle(x_offset,y_offset,1,1,22,11,14+16,TRUE);
END Yellow;


(******************************************************************)
(* This procedure positions icons onto icon buttons.			*)
(******************************************************************)
PROCEDURE PutIcon(x,y,number : INTEGER);
BEGIN
   CASE number OF
         1 :   New(x,y);
      |  2 :   Open(x,y);
      |  3 :   Save(x,y);
      |  4 :   Cut(x,y);
      |  5 :   Copy(x,y);
      |  6 :   Paste(x,y);
      |  7 :   Undo(x,y);
      |  8 :   Redo(x,y);
      |  0 :   Print(x,y);
      |  9 :   Arrow(x,y);
      | 10 :   Pencil(x,y);
      | 11 :   Fill(x,y);
      | 12 :   Circle(x,y);
      | 13 :   Square(x,y);
      | 14 :   FilledSquare(x,y);
      | 15 :   StraightLine(x,y);
      | 16 :   Text(x,y);
      | 17 :   Dropper(x,y);
      | 18 :   Eraser(x,y);
      | 19 :   AirBrush(x,y);
      | 20 :   FilledCircle(x,y);
      | 21 :   Marquee(x,y);
      | 22 :   Zoom(x,y);
      | 26 :   Black(x,y);
      | 27 :   White(x,y);
	| 28 :   Blue(x,y);
	| 29 :   LightGreen(x,y);
	| 30 :   FaintGreen(x,y);
	| 31 :   Red(x,y);
	| 32 :   Violet(x,y);
	| 33 :   FaintRed(x,y);
	| 34 :   LightGrey(x,y);
	| 35 :   DarkGrey(x,y);
	| 36 :   NavyBlue(x,y);
	| 37 :   FluroGreen(x,y);
	| 38 :   FluroBlue(x,y);
	| 39 :   Orange(x,y);
	| 40 :   LightViolet(x,y);
	| 41 :   Yellow(x,y);
	| 42 :   (*Palette(w,x,y);*)
	| 43 :   Help(x,y);
	| 44 :   NoZoom(x,y);
	| 45 :   Info(x,y);
	| 46 :   Brush(x,y);
	| 47 :   Polygon(x,y);
   END; (* CASE *)
END PutIcon;

END Icons.