MODULE Painter;

(******************************************************************)
(*											*)
(*		     		   Program Module					*)
(*											*)
(*	Programmer :	Matthew Ma (c9315720)				*)
(*											*)
(*	Last edited :	22-10-97						*)
(*											*)
(*	Function : 		This is the program module.			*)
(* 											*)
(*	Status :		Working.						*)
(******************************************************************)


FROM Icons IMPORT
(* proc *)   Arrow, Black, New, NoZoom;

FROM ColourRoutines IMPORT
(* proc *)   DrawDefaultPaletteBar;

FROM IconButtons IMPORT
(* proc *)   DrawMenuIconWindow, DrawToolIconWindow, DrawMenuIcon2;

FROM Semaphores IMPORT
(* type *)   Semaphore,
(* proc *)   CreateSemaphore, Wait, Signal, DestroySemaphore;

FROM Bars IMPORT
(* proc *)   DrawStatusBar, DrawIconBar, DrawMenuBar, DrawTitleBar, DrawMenuButtons,
	     	 DrawZoomBox, DrawEmptyWindow;

FROM GraphicWindow IMPORT
(* var  *)   XMAX, YMAX, CharWidth, CharHeight, MaxColour,
(* type *)   GraphicalWindow,
(* proc *)   PutChar, PutLine, Plot, Line, Rectangle;


VAR
  PainterSemaphore : Semaphore;



(******************************************************************)
(* This procedure sets some default values.				*)
(******************************************************************)
PROCEDURE SetDefaults();
BEGIN
   Rectangle(8+3+4-11,5+7+80-6,8+3+5+15+8,5+7+81+23+6,7,TRUE);
   Arrow(8+3+5+1,5+7+81+1);
   Rectangle(89+6-2,YMAX-40,89+33-2,YMAX-24,7,TRUE);
   Black(89+8-2,YMAX-38);
   Rectangle(8,56-2,23+3,71,7,TRUE);
   New(8+2+2,56-2+3);
   Rectangle(8+238,56-2,23+3+238,71,7,TRUE);
   NoZoom(8+238+1,56-2+2);
END SetDefaults;


(******************************************************************)
(* This procedure starts up the program.					*)
(******************************************************************)
PROCEDURE StartUp;
BEGIN
   Wait(PainterSemaphore);
END StartUp;


(*******************)
(* initialisations *)
(*******************)
BEGIN

   DrawStatusBar();
   DrawIconBar();
   DrawMenuBar();
   DrawTitleBar();

   DrawMenuButtons();
   DrawZoomBox();
   DrawMenuIconWindow();
   DrawMenuIcon2();
   DrawToolIconWindow();
   DrawDefaultPaletteBar();

   DrawEmptyWindow();
   SetDefaults();
   CreateSemaphore(PainterSemaphore, 0);
   StartUp;

END Painter.